typedef long unsigned int size_t;
typedef unsigned char __u_char;
typedef unsigned short int __u_short;
typedef unsigned int __u_int;
typedef unsigned long int __u_long;
typedef signed char __int8_t;
typedef unsigned char __uint8_t;
typedef signed short int __int16_t;
typedef unsigned short int __uint16_t;
typedef signed int __int32_t;
typedef unsigned int __uint32_t;
typedef signed long int __int64_t;
typedef unsigned long int __uint64_t;
typedef long int __quad_t;
typedef unsigned long int __u_quad_t;
typedef long int __intmax_t;
typedef unsigned long int __uintmax_t;
typedef unsigned long int __dev_t;
typedef unsigned int __uid_t;
typedef unsigned int __gid_t;
typedef unsigned long int __ino_t;
typedef unsigned long int __ino64_t;
typedef unsigned int __mode_t;
typedef unsigned long int __nlink_t;
typedef long int __off_t;
typedef long int __off64_t;
typedef int __pid_t;
typedef struct { int __val[2]; } __fsid_t;
typedef long int __clock_t;
typedef unsigned long int __rlim_t;
typedef unsigned long int __rlim64_t;
typedef unsigned int __id_t;
typedef long int __time_t;
typedef unsigned int __useconds_t;
typedef long int __suseconds_t;
typedef int __daddr_t;
typedef int __key_t;
typedef int __clockid_t;
typedef void * __timer_t;
typedef long int __blksize_t;
typedef long int __blkcnt_t;
typedef long int __blkcnt64_t;
typedef unsigned long int __fsblkcnt_t;
typedef unsigned long int __fsblkcnt64_t;
typedef unsigned long int __fsfilcnt_t;
typedef unsigned long int __fsfilcnt64_t;
typedef long int __fsword_t;
typedef long int __ssize_t;
typedef long int __syscall_slong_t;
typedef unsigned long int __syscall_ulong_t;
typedef __off64_t __loff_t;
typedef char *__caddr_t;
typedef long int __intptr_t;
typedef unsigned int __socklen_t;
typedef int __sig_atomic_t;
struct _IO_FILE;
typedef struct _IO_FILE __FILE;
struct _IO_FILE;
typedef struct _IO_FILE FILE;
typedef struct
{
  int __count;
  union
  {
    unsigned int __wch;
    char __wchb[4];
  } __value;
} __mbstate_t;
typedef struct
{
  __off_t __pos;
  __mbstate_t __state;
} _G_fpos_t;
typedef struct
{
  __off64_t __pos;
  __mbstate_t __state;
} _G_fpos64_t;
typedef __builtin_va_list va_list;
typedef __builtin_va_list __gnuc_va_list;
struct _IO_jump_t; struct _IO_FILE;
typedef void _IO_lock_t;
struct _IO_marker {
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
  int _pos;
};
enum __codecvt_result
{
  __codecvt_ok,
  __codecvt_partial,
  __codecvt_error,
  __codecvt_noconv
};
struct _IO_FILE {
  int _flags;
  char* _IO_read_ptr;
  char* _IO_read_end;
  char* _IO_read_base;
  char* _IO_write_base;
  char* _IO_write_ptr;
  char* _IO_write_end;
  char* _IO_buf_base;
  char* _IO_buf_end;
  char *_IO_save_base;
  char *_IO_backup_base;
  char *_IO_save_end;
  struct _IO_marker *_markers;
  struct _IO_FILE *_chain;
  int _fileno;
  int _flags2;
  __off_t _old_offset;
  unsigned short _cur_column;
  signed char _vtable_offset;
  char _shortbuf[1];
  _IO_lock_t *_lock;
  __off64_t _offset;
  void *__pad1;
  void *__pad2;
  void *__pad3;
  void *__pad4;
  size_t __pad5;
  int _mode;
  char _unused2[15 * sizeof (int) - 4 * sizeof (void *) - sizeof (size_t)];
};
typedef struct _IO_FILE _IO_FILE;
struct _IO_FILE_plus;
extern struct _IO_FILE_plus _IO_2_1_stdin_;
extern struct _IO_FILE_plus _IO_2_1_stdout_;
extern struct _IO_FILE_plus _IO_2_1_stderr_;
typedef __ssize_t __io_read_fn (void *__cookie, char *__buf, size_t __nbytes);
typedef __ssize_t __io_write_fn (void *__cookie, const char *__buf,
     size_t __n);
typedef int __io_seek_fn (void *__cookie, __off64_t *__pos, int __w);
typedef int __io_close_fn (void *__cookie);
extern int __underflow (_IO_FILE *);
extern int __uflow (_IO_FILE *);
extern int __overflow (_IO_FILE *, int);
extern int _IO_getc (_IO_FILE *__fp);
extern int _IO_putc (int __c, _IO_FILE *__fp);
extern int _IO_feof (_IO_FILE *__fp) __attribute__ ((__nothrow__ ));
extern int _IO_ferror (_IO_FILE *__fp) __attribute__ ((__nothrow__ ));
extern int _IO_peekc_locked (_IO_FILE *__fp);
extern void _IO_flockfile (_IO_FILE *) __attribute__ ((__nothrow__ ));
extern void _IO_funlockfile (_IO_FILE *) __attribute__ ((__nothrow__ ));
extern int _IO_ftrylockfile (_IO_FILE *) __attribute__ ((__nothrow__ ));
extern int _IO_vfscanf (_IO_FILE * __restrict, const char * __restrict,
   __gnuc_va_list, int *__restrict);
extern int _IO_vfprintf (_IO_FILE *__restrict, const char *__restrict,
    __gnuc_va_list);
extern __ssize_t _IO_padn (_IO_FILE *, int, __ssize_t);
extern size_t _IO_sgetn (_IO_FILE *, void *, size_t);
extern __off64_t _IO_seekoff (_IO_FILE *, __off64_t, int, int);
extern __off64_t _IO_seekpos (_IO_FILE *, __off64_t, int);
extern void _IO_free_backup_area (_IO_FILE *) __attribute__ ((__nothrow__ ));
typedef __gnuc_va_list va_list;
typedef __off_t off_t;
typedef __ssize_t ssize_t;
typedef _G_fpos_t fpos_t;
extern struct _IO_FILE *stdin;
extern struct _IO_FILE *stdout;
extern struct _IO_FILE *stderr;
extern int remove (const char *__filename) __attribute__ ((__nothrow__ ));
extern int rename (const char *__old, const char *__new) __attribute__ ((__nothrow__ ));
extern int renameat (int __oldfd, const char *__old, int __newfd,
       const char *__new) __attribute__ ((__nothrow__ ));
extern FILE *tmpfile (void) ;
extern char *tmpnam (char *__s) __attribute__ ((__nothrow__ )) ;
extern char *tmpnam_r (char *__s) __attribute__ ((__nothrow__ )) ;
extern char *tempnam (const char *__dir, const char *__pfx)
     __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) ;
extern int fclose (FILE *__stream);
extern int fflush (FILE *__stream);
extern int fflush_unlocked (FILE *__stream);
extern FILE *fopen (const char *__restrict __filename,
      const char *__restrict __modes) ;
extern FILE *freopen (const char *__restrict __filename,
        const char *__restrict __modes,
        FILE *__restrict __stream) ;
extern FILE *fdopen (int __fd, const char *__modes) __attribute__ ((__nothrow__ )) ;
extern FILE *fmemopen (void *__s, size_t __len, const char *__modes)
  __attribute__ ((__nothrow__ )) ;
extern FILE *open_memstream (char **__bufloc, size_t *__sizeloc) __attribute__ ((__nothrow__ )) ;
extern void setbuf (FILE *__restrict __stream, char *__restrict __buf) __attribute__ ((__nothrow__ ));
extern int setvbuf (FILE *__restrict __stream, char *__restrict __buf,
      int __modes, size_t __n) __attribute__ ((__nothrow__ ));
extern void setbuffer (FILE *__restrict __stream, char *__restrict __buf,
         size_t __size) __attribute__ ((__nothrow__ ));
extern void setlinebuf (FILE *__stream) __attribute__ ((__nothrow__ ));
extern int fprintf (FILE *__restrict __stream,
      const char *__restrict __format, ...);
extern int printf (const char *__restrict __format, ...);
extern int sprintf (char *__restrict __s,
      const char *__restrict __format, ...) __attribute__ ((__nothrow__));
extern int vfprintf (FILE *__restrict __s, const char *__restrict __format,
       __gnuc_va_list __arg);
extern int vprintf (const char *__restrict __format, __gnuc_va_list __arg);
extern int vsprintf (char *__restrict __s, const char *__restrict __format,
       __gnuc_va_list __arg) __attribute__ ((__nothrow__));
extern int snprintf (char *__restrict __s, size_t __maxlen,
       const char *__restrict __format, ...)
     __attribute__ ((__nothrow__)) __attribute__ ((__format__ (__printf__, 3, 4)));
extern int vsnprintf (char *__restrict __s, size_t __maxlen,
        const char *__restrict __format, __gnuc_va_list __arg)
     __attribute__ ((__nothrow__)) __attribute__ ((__format__ (__printf__, 3, 0)));
extern int vdprintf (int __fd, const char *__restrict __fmt,
       __gnuc_va_list __arg)
     __attribute__ ((__format__ (__printf__, 2, 0)));
extern int dprintf (int __fd, const char *__restrict __fmt, ...)
     __attribute__ ((__format__ (__printf__, 2, 3)));
extern int fscanf (FILE *__restrict __stream,
     const char *__restrict __format, ...) ;
extern int scanf (const char *__restrict __format, ...) ;
extern int sscanf (const char *__restrict __s,
     const char *__restrict __format, ...) __attribute__ ((__nothrow__ ));
extern int fscanf (FILE *__restrict __stream, const char *__restrict __format, ...) __asm__ ("" "__isoc99_fscanf") ;
extern int scanf (const char *__restrict __format, ...) __asm__ ("" "__isoc99_scanf") ;
extern int sscanf (const char *__restrict __s, const char *__restrict __format, ...) __asm__ ("" "__isoc99_sscanf") __attribute__ ((__nothrow__ ));
extern int vfscanf (FILE *__restrict __s, const char *__restrict __format,
      __gnuc_va_list __arg)
     __attribute__ ((__format__ (__scanf__, 2, 0))) ;
extern int vscanf (const char *__restrict __format, __gnuc_va_list __arg)
     __attribute__ ((__format__ (__scanf__, 1, 0))) ;
extern int vsscanf (const char *__restrict __s,
      const char *__restrict __format, __gnuc_va_list __arg)
     __attribute__ ((__nothrow__ )) __attribute__ ((__format__ (__scanf__, 2, 0)));
extern int vfscanf (FILE *__restrict __s, const char *__restrict __format, __gnuc_va_list __arg) __asm__ ("" "__isoc99_vfscanf")
     __attribute__ ((__format__ (__scanf__, 2, 0))) ;
extern int vscanf (const char *__restrict __format, __gnuc_va_list __arg) __asm__ ("" "__isoc99_vscanf")
     __attribute__ ((__format__ (__scanf__, 1, 0))) ;
extern int vsscanf (const char *__restrict __s, const char *__restrict __format, __gnuc_va_list __arg) __asm__ ("" "__isoc99_vsscanf") __attribute__ ((__nothrow__ ))
     __attribute__ ((__format__ (__scanf__, 2, 0)));
extern int fgetc (FILE *__stream);
extern int getc (FILE *__stream);
extern int getchar (void);
extern int getc_unlocked (FILE *__stream);
extern int getchar_unlocked (void);
extern int fgetc_unlocked (FILE *__stream);
extern int fputc (int __c, FILE *__stream);
extern int putc (int __c, FILE *__stream);
extern int putchar (int __c);
extern int fputc_unlocked (int __c, FILE *__stream);
extern int putc_unlocked (int __c, FILE *__stream);
extern int putchar_unlocked (int __c);
extern int getw (FILE *__stream);
extern int putw (int __w, FILE *__stream);
extern char *fgets (char *__restrict __s, int __n, FILE *__restrict __stream)
          ;
extern __ssize_t __getdelim (char **__restrict __lineptr,
          size_t *__restrict __n, int __delimiter,
          FILE *__restrict __stream) ;
extern __ssize_t getdelim (char **__restrict __lineptr,
        size_t *__restrict __n, int __delimiter,
        FILE *__restrict __stream) ;
extern __ssize_t getline (char **__restrict __lineptr,
       size_t *__restrict __n,
       FILE *__restrict __stream) ;
extern int fputs (const char *__restrict __s, FILE *__restrict __stream);
extern int puts (const char *__s);
extern int ungetc (int __c, FILE *__stream);
extern size_t fread (void *__restrict __ptr, size_t __size,
       size_t __n, FILE *__restrict __stream) ;
extern size_t fwrite (const void *__restrict __ptr, size_t __size,
        size_t __n, FILE *__restrict __s);
extern size_t fread_unlocked (void *__restrict __ptr, size_t __size,
         size_t __n, FILE *__restrict __stream) ;
extern size_t fwrite_unlocked (const void *__restrict __ptr, size_t __size,
          size_t __n, FILE *__restrict __stream);
extern int fseek (FILE *__stream, long int __off, int __whence);
extern long int ftell (FILE *__stream) ;
extern void rewind (FILE *__stream);
extern int fseeko (FILE *__stream, __off_t __off, int __whence);
extern __off_t ftello (FILE *__stream) ;
extern int fgetpos (FILE *__restrict __stream, fpos_t *__restrict __pos);
extern int fsetpos (FILE *__stream, const fpos_t *__pos);
extern void clearerr (FILE *__stream) __attribute__ ((__nothrow__ ));
extern int feof (FILE *__stream) __attribute__ ((__nothrow__ )) ;
extern int ferror (FILE *__stream) __attribute__ ((__nothrow__ )) ;
extern void clearerr_unlocked (FILE *__stream) __attribute__ ((__nothrow__ ));
extern int feof_unlocked (FILE *__stream) __attribute__ ((__nothrow__ )) ;
extern int ferror_unlocked (FILE *__stream) __attribute__ ((__nothrow__ )) ;
extern void perror (const char *__s);
extern int sys_nerr;
extern const char *const sys_errlist[];
extern int fileno (FILE *__stream) __attribute__ ((__nothrow__ )) ;
extern int fileno_unlocked (FILE *__stream) __attribute__ ((__nothrow__ )) ;
extern FILE *popen (const char *__command, const char *__modes) ;
extern int pclose (FILE *__stream);
extern char *ctermid (char *__s) __attribute__ ((__nothrow__ ));
extern void flockfile (FILE *__stream) __attribute__ ((__nothrow__ ));
extern int ftrylockfile (FILE *__stream) __attribute__ ((__nothrow__ )) ;
extern void funlockfile (FILE *__stream) __attribute__ ((__nothrow__ ));
typedef int wchar_t;
typedef enum
{
  P_ALL,
  P_PID,
  P_PGID
} idtype_t;
typedef float _Float32;
typedef double _Float64;
typedef double _Float32x;
typedef long double _Float64x;
typedef struct
  {
    int quot;
    int rem;
  } div_t;
typedef struct
  {
    long int quot;
    long int rem;
  } ldiv_t;
__extension__ typedef struct
  {
    long long int quot;
    long long int rem;
  } lldiv_t;
extern size_t __ctype_get_mb_cur_max (void) __attribute__ ((__nothrow__ )) ;
extern double atof (const char *__nptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1))) ;
extern int atoi (const char *__nptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1))) ;
extern long int atol (const char *__nptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1))) ;
__extension__ extern long long int atoll (const char *__nptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1))) ;
extern double strtod (const char *__restrict __nptr,
        char **__restrict __endptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern float strtof (const char *__restrict __nptr,
       char **__restrict __endptr) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern long double strtold (const char *__restrict __nptr,
       char **__restrict __endptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern long int strtol (const char *__restrict __nptr,
   char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern unsigned long int strtoul (const char *__restrict __nptr,
      char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
__extension__
extern long long int strtoq (const char *__restrict __nptr,
        char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
__extension__
extern unsigned long long int strtouq (const char *__restrict __nptr,
           char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
__extension__
extern long long int strtoll (const char *__restrict __nptr,
         char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
__extension__
extern unsigned long long int strtoull (const char *__restrict __nptr,
     char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern char *l64a (long int __n) __attribute__ ((__nothrow__ )) ;
extern long int a64l (const char *__s)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1))) ;
typedef __u_char u_char;
typedef __u_short u_short;
typedef __u_int u_int;
typedef __u_long u_long;
typedef __quad_t quad_t;
typedef __u_quad_t u_quad_t;
typedef __fsid_t fsid_t;
typedef __loff_t loff_t;
typedef __ino_t ino_t;
typedef __dev_t dev_t;
typedef __gid_t gid_t;
typedef __mode_t mode_t;
typedef __nlink_t nlink_t;
typedef __uid_t uid_t;
typedef __pid_t pid_t;
typedef __id_t id_t;
typedef __daddr_t daddr_t;
typedef __caddr_t caddr_t;
typedef __key_t key_t;
typedef __clock_t clock_t;
typedef __clockid_t clockid_t;
typedef __time_t time_t;
typedef __timer_t timer_t;
typedef unsigned long int ulong;
typedef unsigned short int ushort;
typedef unsigned int uint;
typedef __int8_t int8_t;
typedef __int16_t int16_t;
typedef __int32_t int32_t;
typedef __int64_t int64_t;
typedef unsigned int u_int8_t __attribute__ ((__mode__ (__QI__)));
typedef unsigned int u_int16_t __attribute__ ((__mode__ (__HI__)));
typedef unsigned int u_int32_t __attribute__ ((__mode__ (__SI__)));
typedef unsigned int u_int64_t __attribute__ ((__mode__ (__DI__)));
typedef int register_t __attribute__ ((__mode__ (__word__)));
static __uint16_t
__uint16_identity (__uint16_t __x)
;
static __uint32_t
__uint32_identity (__uint32_t __x)
;
static __uint64_t
__uint64_identity (__uint64_t __x)
;
typedef struct
{
  unsigned long int __val[(1024 / (8 * sizeof (unsigned long int)))];
} __sigset_t;
typedef __sigset_t sigset_t;
struct timeval
{
  __time_t tv_sec;
  __suseconds_t tv_usec;
};
struct timespec
{
  __time_t tv_sec;
  __syscall_slong_t tv_nsec;
};
typedef __suseconds_t suseconds_t;
typedef long int __fd_mask;
typedef struct
  {
    __fd_mask __fds_bits[1024 / (8 * (int) sizeof (__fd_mask))];
  } fd_set;
typedef __fd_mask fd_mask;
extern int select (int __nfds, fd_set *__restrict __readfds,
     fd_set *__restrict __writefds,
     fd_set *__restrict __exceptfds,
     struct timeval *__restrict __timeout);
extern int pselect (int __nfds, fd_set *__restrict __readfds,
      fd_set *__restrict __writefds,
      fd_set *__restrict __exceptfds,
      const struct timespec *__restrict __timeout,
      const __sigset_t *__restrict __sigmask);
extern unsigned int gnu_dev_major (__dev_t __dev) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern unsigned int gnu_dev_minor (__dev_t __dev) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern __dev_t gnu_dev_makedev (unsigned int __major, unsigned int __minor) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
typedef __blksize_t blksize_t;
typedef __blkcnt_t blkcnt_t;
typedef __fsblkcnt_t fsblkcnt_t;
typedef __fsfilcnt_t fsfilcnt_t;
struct __pthread_rwlock_arch_t
{
  unsigned int __readers;
  unsigned int __writers;
  unsigned int __wrphase_futex;
  unsigned int __writers_futex;
  unsigned int __pad3;
  unsigned int __pad4;
  int __cur_writer;
  int __shared;
  signed char __rwelision;
  unsigned char __pad1[7];
  unsigned long int __pad2;
  unsigned int __flags;
};
typedef struct __pthread_internal_list
{
  struct __pthread_internal_list *__prev;
  struct __pthread_internal_list *__next;
} __pthread_list_t;
struct __pthread_mutex_s
{
  int __lock ;
  unsigned int __count;
  int __owner;
  unsigned int __nusers;
  int __kind;
  short __spins; short __elision;
  __pthread_list_t __list;
};
struct __pthread_cond_s
{
  __extension__ union
  {
    __extension__ unsigned long long int __wseq;
    struct
    {
      unsigned int __low;
      unsigned int __high;
    } __wseq32;
  };
  __extension__ union
  {
    __extension__ unsigned long long int __g1_start;
    struct
    {
      unsigned int __low;
      unsigned int __high;
    } __g1_start32;
  };
  unsigned int __g_refs[2] ;
  unsigned int __g_size[2];
  unsigned int __g1_orig_size;
  unsigned int __wrefs;
  unsigned int __g_signals[2];
};
typedef unsigned long int pthread_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_mutexattr_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_condattr_t;
typedef unsigned int pthread_key_t;
typedef int pthread_once_t;
union pthread_attr_t
{
  char __size[56];
  long int __align;
};
typedef union pthread_attr_t pthread_attr_t;
typedef union
{
  struct __pthread_mutex_s __data;
  char __size[40];
  long int __align;
} pthread_mutex_t;
typedef union
{
  struct __pthread_cond_s __data;
  char __size[48];
  __extension__ long long int __align;
} pthread_cond_t;
typedef union
{
  struct __pthread_rwlock_arch_t __data;
  char __size[56];
  long int __align;
} pthread_rwlock_t;
typedef union
{
  char __size[8];
  long int __align;
} pthread_rwlockattr_t;
typedef volatile int pthread_spinlock_t;
typedef union
{
  char __size[32];
  long int __align;
} pthread_barrier_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_barrierattr_t;
extern long int random (void) __attribute__ ((__nothrow__ ));
extern void srandom (unsigned int __seed) __attribute__ ((__nothrow__ ));
extern char *initstate (unsigned int __seed, char *__statebuf,
   size_t __statelen) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern char *setstate (char *__statebuf) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
struct random_data
  {
    int32_t *fptr;
    int32_t *rptr;
    int32_t *state;
    int rand_type;
    int rand_deg;
    int rand_sep;
    int32_t *end_ptr;
  };
extern int random_r (struct random_data *__restrict __buf,
       int32_t *__restrict __result) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int srandom_r (unsigned int __seed, struct random_data *__buf)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern int initstate_r (unsigned int __seed, char *__restrict __statebuf,
   size_t __statelen,
   struct random_data *__restrict __buf)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 4)));
extern int setstate_r (char *__restrict __statebuf,
         struct random_data *__restrict __buf)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int rand (void) __attribute__ ((__nothrow__ ));
extern void srand (unsigned int __seed) __attribute__ ((__nothrow__ ));
extern int rand_r (unsigned int *__seed) __attribute__ ((__nothrow__ ));
extern double drand48 (void) __attribute__ ((__nothrow__ ));
extern double erand48 (unsigned short int __xsubi[3]) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern long int lrand48 (void) __attribute__ ((__nothrow__ ));
extern long int nrand48 (unsigned short int __xsubi[3])
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern long int mrand48 (void) __attribute__ ((__nothrow__ ));
extern long int jrand48 (unsigned short int __xsubi[3])
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern void srand48 (long int __seedval) __attribute__ ((__nothrow__ ));
extern unsigned short int *seed48 (unsigned short int __seed16v[3])
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern void lcong48 (unsigned short int __param[7]) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
struct drand48_data
  {
    unsigned short int __x[3];
    unsigned short int __old_x[3];
    unsigned short int __c;
    unsigned short int __init;
    __extension__ unsigned long long int __a;
  };
extern int drand48_r (struct drand48_data *__restrict __buffer,
        double *__restrict __result) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int erand48_r (unsigned short int __xsubi[3],
        struct drand48_data *__restrict __buffer,
        double *__restrict __result) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int lrand48_r (struct drand48_data *__restrict __buffer,
        long int *__restrict __result)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int nrand48_r (unsigned short int __xsubi[3],
        struct drand48_data *__restrict __buffer,
        long int *__restrict __result)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int mrand48_r (struct drand48_data *__restrict __buffer,
        long int *__restrict __result)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int jrand48_r (unsigned short int __xsubi[3],
        struct drand48_data *__restrict __buffer,
        long int *__restrict __result)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int srand48_r (long int __seedval, struct drand48_data *__buffer)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern int seed48_r (unsigned short int __seed16v[3],
       struct drand48_data *__buffer) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int lcong48_r (unsigned short int __param[7],
        struct drand48_data *__buffer)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern void *malloc (size_t __size) __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) ;
extern void *calloc (size_t __nmemb, size_t __size)
     __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) ;
extern void *realloc (void *__ptr, size_t __size)
     __attribute__ ((__nothrow__ )) __attribute__ ((__warn_unused_result__));
extern void free (void *__ptr) __attribute__ ((__nothrow__ ));
extern void *alloca (size_t __size) __attribute__ ((__nothrow__ ));
extern void *valloc (size_t __size) __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) ;
extern int posix_memalign (void **__memptr, size_t __alignment, size_t __size)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern void *aligned_alloc (size_t __alignment, size_t __size)
     __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) ;
extern void abort (void) __attribute__ ((__nothrow__ )) __attribute__ ((__noreturn__));
extern int atexit (void (*__func) (void)) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int at_quick_exit (void (*__func) (void)) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int on_exit (void (*__func) (int __status, void *__arg), void *__arg)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern void exit (int __status) __attribute__ ((__nothrow__ )) __attribute__ ((__noreturn__));
extern void quick_exit (int __status) __attribute__ ((__nothrow__ )) __attribute__ ((__noreturn__));
extern void _Exit (int __status) __attribute__ ((__nothrow__ )) __attribute__ ((__noreturn__));
extern char *getenv (const char *__name) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern int putenv (char *__string) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int setenv (const char *__name, const char *__value, int __replace)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern int unsetenv (const char *__name) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int clearenv (void) __attribute__ ((__nothrow__ ));
extern char *mktemp (char *__template) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int mkstemp (char *__template) __attribute__ ((__nonnull__ (1))) ;
extern int mkstemps (char *__template, int __suffixlen) __attribute__ ((__nonnull__ (1))) ;
extern char *mkdtemp (char *__template) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern int system (const char *__command) ;
extern char *realpath (const char *__restrict __name,
         char *__restrict __resolved) __attribute__ ((__nothrow__ )) ;
typedef int (*__compar_fn_t) (const void *, const void *);
extern void *bsearch (const void *__key, const void *__base,
        size_t __nmemb, size_t __size, __compar_fn_t __compar)
     __attribute__ ((__nonnull__ (1, 2, 5))) ;
extern void qsort (void *__base, size_t __nmemb, size_t __size,
     __compar_fn_t __compar) __attribute__ ((__nonnull__ (1, 4)));
extern int abs (int __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)) ;
extern long int labs (long int __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)) ;
__extension__ extern long long int llabs (long long int __x)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__)) ;
extern div_t div (int __numer, int __denom)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__)) ;
extern ldiv_t ldiv (long int __numer, long int __denom)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__)) ;
__extension__ extern lldiv_t lldiv (long long int __numer,
        long long int __denom)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__)) ;
extern char *ecvt (double __value, int __ndigit, int *__restrict __decpt,
     int *__restrict __sign) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4))) ;
extern char *fcvt (double __value, int __ndigit, int *__restrict __decpt,
     int *__restrict __sign) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4))) ;
extern char *gcvt (double __value, int __ndigit, char *__buf)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3))) ;
extern char *qecvt (long double __value, int __ndigit,
      int *__restrict __decpt, int *__restrict __sign)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4))) ;
extern char *qfcvt (long double __value, int __ndigit,
      int *__restrict __decpt, int *__restrict __sign)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4))) ;
extern char *qgcvt (long double __value, int __ndigit, char *__buf)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3))) ;
extern int ecvt_r (double __value, int __ndigit, int *__restrict __decpt,
     int *__restrict __sign, char *__restrict __buf,
     size_t __len) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4, 5)));
extern int fcvt_r (double __value, int __ndigit, int *__restrict __decpt,
     int *__restrict __sign, char *__restrict __buf,
     size_t __len) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4, 5)));
extern int qecvt_r (long double __value, int __ndigit,
      int *__restrict __decpt, int *__restrict __sign,
      char *__restrict __buf, size_t __len)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4, 5)));
extern int qfcvt_r (long double __value, int __ndigit,
      int *__restrict __decpt, int *__restrict __sign,
      char *__restrict __buf, size_t __len)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4, 5)));
extern int mblen (const char *__s, size_t __n) __attribute__ ((__nothrow__ ));
extern int mbtowc (wchar_t *__restrict __pwc,
     const char *__restrict __s, size_t __n) __attribute__ ((__nothrow__ ));
extern int wctomb (char *__s, wchar_t __wchar) __attribute__ ((__nothrow__ ));
extern size_t mbstowcs (wchar_t *__restrict __pwcs,
   const char *__restrict __s, size_t __n) __attribute__ ((__nothrow__ ));
extern size_t wcstombs (char *__restrict __s,
   const wchar_t *__restrict __pwcs, size_t __n)
     __attribute__ ((__nothrow__ ));
extern int rpmatch (const char *__response) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern int getsubopt (char **__restrict __optionp,
        char *const *__restrict __tokens,
        char **__restrict __valuep)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2, 3))) ;
extern int getloadavg (double __loadavg[], int __nelem)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
typedef __uint8_t uint8_t;
typedef __uint16_t uint16_t;
typedef __uint32_t uint32_t;
typedef __uint64_t uint64_t;
typedef signed char int_least8_t;
typedef short int int_least16_t;
typedef int int_least32_t;
typedef long int int_least64_t;
typedef unsigned char uint_least8_t;
typedef unsigned short int uint_least16_t;
typedef unsigned int uint_least32_t;
typedef unsigned long int uint_least64_t;
typedef signed char int_fast8_t;
typedef long int int_fast16_t;
typedef long int int_fast32_t;
typedef long int int_fast64_t;
typedef unsigned char uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long int uint_fast64_t;
typedef long int intptr_t;
typedef unsigned long int uintptr_t;
typedef __intmax_t intmax_t;
typedef __uintmax_t uintmax_t;
typedef long int ptrdiff_t;
typedef struct {
  long long __clang_max_align_nonce1
      __attribute__((__aligned__(__alignof__(long long))));
  long double __clang_max_align_nonce2
      __attribute__((__aligned__(__alignof__(long double))));
} max_align_t;
extern void *memcpy (void *__restrict __dest, const void *__restrict __src,
       size_t __n) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern void *memmove (void *__dest, const void *__src, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern void *memccpy (void *__restrict __dest, const void *__restrict __src,
        int __c, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern void *memset (void *__s, int __c, size_t __n) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int memcmp (const void *__s1, const void *__s2, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern void *memchr (const void *__s, int __c, size_t __n)
      __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern char *strcpy (char *__restrict __dest, const char *__restrict __src)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern char *strncpy (char *__restrict __dest,
        const char *__restrict __src, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern char *strcat (char *__restrict __dest, const char *__restrict __src)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern char *strncat (char *__restrict __dest, const char *__restrict __src,
        size_t __n) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int strcmp (const char *__s1, const char *__s2)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern int strncmp (const char *__s1, const char *__s2, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern int strcoll (const char *__s1, const char *__s2)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern size_t strxfrm (char *__restrict __dest,
         const char *__restrict __src, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
struct __locale_struct
{
  struct __locale_data *__locales[13];
  const unsigned short int *__ctype_b;
  const int *__ctype_tolower;
  const int *__ctype_toupper;
  const char *__names[13];
};
typedef struct __locale_struct *__locale_t;
typedef __locale_t locale_t;
extern int strcoll_l (const char *__s1, const char *__s2, locale_t __l)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2, 3)));
extern size_t strxfrm_l (char *__dest, const char *__src, size_t __n,
    locale_t __l) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 4)));
extern char *strdup (const char *__s)
     __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) __attribute__ ((__nonnull__ (1)));
extern char *strndup (const char *__string, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) __attribute__ ((__nonnull__ (1)));
extern char *strchr (const char *__s, int __c)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern char *strrchr (const char *__s, int __c)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern size_t strcspn (const char *__s, const char *__reject)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern size_t strspn (const char *__s, const char *__accept)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern char *strpbrk (const char *__s, const char *__accept)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern char *strstr (const char *__haystack, const char *__needle)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern char *strtok (char *__restrict __s, const char *__restrict __delim)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern char *__strtok_r (char *__restrict __s,
    const char *__restrict __delim,
    char **__restrict __save_ptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 3)));
extern char *strtok_r (char *__restrict __s, const char *__restrict __delim,
         char **__restrict __save_ptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 3)));
extern size_t strlen (const char *__s)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern size_t strnlen (const char *__string, size_t __maxlen)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern char *strerror (int __errnum) __attribute__ ((__nothrow__ ));
extern int strerror_r (int __errnum, char *__buf, size_t __buflen) __asm__ ("" "__xpg_strerror_r") __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern char *strerror_l (int __errnum, locale_t __l) __attribute__ ((__nothrow__ ));
extern int bcmp (const void *__s1, const void *__s2, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern void bcopy (const void *__src, void *__dest, size_t __n)
  __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern void bzero (void *__s, size_t __n) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern char *index (const char *__s, int __c)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern char *rindex (const char *__s, int __c)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern int ffs (int __i) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int ffsl (long int __l) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
__extension__ extern int ffsll (long long int __ll)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int strcasecmp (const char *__s1, const char *__s2)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern int strncasecmp (const char *__s1, const char *__s2, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern int strcasecmp_l (const char *__s1, const char *__s2, locale_t __loc)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2, 3)));
extern int strncasecmp_l (const char *__s1, const char *__s2,
     size_t __n, locale_t __loc)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2, 4)));
extern void explicit_bzero (void *__s, size_t __n) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern char *strsep (char **__restrict __stringp,
       const char *__restrict __delim)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern char *strsignal (int __sig) __attribute__ ((__nothrow__ ));
extern char *__stpcpy (char *__restrict __dest, const char *__restrict __src)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern char *stpcpy (char *__restrict __dest, const char *__restrict __src)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern char *__stpncpy (char *__restrict __dest,
   const char *__restrict __src, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern char *stpncpy (char *__restrict __dest,
        const char *__restrict __src, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern void *malloc (size_t __size) __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) ;
extern void *calloc (size_t __nmemb, size_t __size)
__attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) ;
extern void *realloc (void *__ptr, size_t __size)
__attribute__ ((__nothrow__ )) __attribute__ ((__warn_unused_result__));
extern void *reallocarray (void *__ptr, size_t __nmemb, size_t __size)
__attribute__ ((__nothrow__ )) __attribute__ ((__warn_unused_result__));
extern void free (void *__ptr) __attribute__ ((__nothrow__ ));
extern void *memalign (size_t __alignment, size_t __size)
__attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) ;
extern void *valloc (size_t __size) __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) ;
extern void *pvalloc (size_t __size) __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) ;
extern void *(*__morecore) (ptrdiff_t __size);
extern void *__default_morecore (ptrdiff_t __size)
__attribute__ ((__nothrow__ )) __attribute__ ((__malloc__));
struct mallinfo
{
  int arena;
  int ordblks;
  int smblks;
  int hblks;
  int hblkhd;
  int usmblks;
  int fsmblks;
  int uordblks;
  int fordblks;
  int keepcost;
};
extern struct mallinfo mallinfo (void) __attribute__ ((__nothrow__ ));
extern int mallopt (int __param, int __val) __attribute__ ((__nothrow__ ));
extern int malloc_trim (size_t __pad) __attribute__ ((__nothrow__ ));
extern size_t malloc_usable_size (void *__ptr) __attribute__ ((__nothrow__ ));
extern void malloc_stats (void) __attribute__ ((__nothrow__ ));
extern int malloc_info (int __options, FILE *__fp) __attribute__ ((__nothrow__ ));
extern void (*volatile __free_hook) (void *__ptr,
                                                   const void *)
__attribute__ ((__deprecated__));
extern void *(*volatile __malloc_hook)(size_t __size,
                                                     const void *)
__attribute__ ((__deprecated__));
extern void *(*volatile __realloc_hook)(void *__ptr,
                                                      size_t __size,
                                                      const void *)
__attribute__ ((__deprecated__));
extern void *(*volatile __memalign_hook)(size_t __alignment,
                                                       size_t __size,
                                                       const void *)
__attribute__ ((__deprecated__));
extern void (*volatile __after_morecore_hook) (void);
extern void __malloc_check_init (void) __attribute__ ((__nothrow__ )) __attribute__ ((__deprecated__));
typedef float float_t;
typedef double double_t;
extern int __fpclassify (double __value) __attribute__ ((__nothrow__ ))
     __attribute__ ((__const__));
extern int __signbit (double __value) __attribute__ ((__nothrow__ ))
     __attribute__ ((__const__));
extern int __isinf (double __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int __finite (double __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int __isnan (double __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int __iseqsig (double __x, double __y) __attribute__ ((__nothrow__ ));
extern int __issignaling (double __value) __attribute__ ((__nothrow__ ))
     __attribute__ ((__const__));
extern double acos (double __x) __attribute__ ((__nothrow__ )); extern double __acos (double __x) __attribute__ ((__nothrow__ ));
extern double asin (double __x) __attribute__ ((__nothrow__ )); extern double __asin (double __x) __attribute__ ((__nothrow__ ));
extern double atan (double __x) __attribute__ ((__nothrow__ )); extern double __atan (double __x) __attribute__ ((__nothrow__ ));
extern double atan2 (double __y, double __x) __attribute__ ((__nothrow__ )); extern double __atan2 (double __y, double __x) __attribute__ ((__nothrow__ ));
 extern double cos (double __x) __attribute__ ((__nothrow__ )); extern double __cos (double __x) __attribute__ ((__nothrow__ ));
 extern double sin (double __x) __attribute__ ((__nothrow__ )); extern double __sin (double __x) __attribute__ ((__nothrow__ ));
extern double tan (double __x) __attribute__ ((__nothrow__ )); extern double __tan (double __x) __attribute__ ((__nothrow__ ));
extern double cosh (double __x) __attribute__ ((__nothrow__ )); extern double __cosh (double __x) __attribute__ ((__nothrow__ ));
extern double sinh (double __x) __attribute__ ((__nothrow__ )); extern double __sinh (double __x) __attribute__ ((__nothrow__ ));
extern double tanh (double __x) __attribute__ ((__nothrow__ )); extern double __tanh (double __x) __attribute__ ((__nothrow__ ));
extern double acosh (double __x) __attribute__ ((__nothrow__ )); extern double __acosh (double __x) __attribute__ ((__nothrow__ ));
extern double asinh (double __x) __attribute__ ((__nothrow__ )); extern double __asinh (double __x) __attribute__ ((__nothrow__ ));
extern double atanh (double __x) __attribute__ ((__nothrow__ )); extern double __atanh (double __x) __attribute__ ((__nothrow__ ));
 extern double exp (double __x) __attribute__ ((__nothrow__ )); extern double __exp (double __x) __attribute__ ((__nothrow__ ));
extern double frexp (double __x, int *__exponent) __attribute__ ((__nothrow__ )); extern double __frexp (double __x, int *__exponent) __attribute__ ((__nothrow__ ));
extern double ldexp (double __x, int __exponent) __attribute__ ((__nothrow__ )); extern double __ldexp (double __x, int __exponent) __attribute__ ((__nothrow__ ));
 extern double log (double __x) __attribute__ ((__nothrow__ )); extern double __log (double __x) __attribute__ ((__nothrow__ ));
extern double log10 (double __x) __attribute__ ((__nothrow__ )); extern double __log10 (double __x) __attribute__ ((__nothrow__ ));
extern double modf (double __x, double *__iptr) __attribute__ ((__nothrow__ )); extern double __modf (double __x, double *__iptr) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern double expm1 (double __x) __attribute__ ((__nothrow__ )); extern double __expm1 (double __x) __attribute__ ((__nothrow__ ));
extern double log1p (double __x) __attribute__ ((__nothrow__ )); extern double __log1p (double __x) __attribute__ ((__nothrow__ ));
extern double logb (double __x) __attribute__ ((__nothrow__ )); extern double __logb (double __x) __attribute__ ((__nothrow__ ));
extern double exp2 (double __x) __attribute__ ((__nothrow__ )); extern double __exp2 (double __x) __attribute__ ((__nothrow__ ));
extern double log2 (double __x) __attribute__ ((__nothrow__ )); extern double __log2 (double __x) __attribute__ ((__nothrow__ ));
 extern double pow (double __x, double __y) __attribute__ ((__nothrow__ )); extern double __pow (double __x, double __y) __attribute__ ((__nothrow__ ));
extern double sqrt (double __x) __attribute__ ((__nothrow__ )); extern double __sqrt (double __x) __attribute__ ((__nothrow__ ));
extern double hypot (double __x, double __y) __attribute__ ((__nothrow__ )); extern double __hypot (double __x, double __y) __attribute__ ((__nothrow__ ));
extern double cbrt (double __x) __attribute__ ((__nothrow__ )); extern double __cbrt (double __x) __attribute__ ((__nothrow__ ));
extern double ceil (double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern double __ceil (double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern double fabs (double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern double __fabs (double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern double floor (double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern double __floor (double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern double fmod (double __x, double __y) __attribute__ ((__nothrow__ )); extern double __fmod (double __x, double __y) __attribute__ ((__nothrow__ ));
extern int isinf (double __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int finite (double __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern double drem (double __x, double __y) __attribute__ ((__nothrow__ )); extern double __drem (double __x, double __y) __attribute__ ((__nothrow__ ));
extern double significand (double __x) __attribute__ ((__nothrow__ )); extern double __significand (double __x) __attribute__ ((__nothrow__ ));
extern double copysign (double __x, double __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern double __copysign (double __x, double __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern double nan (const char *__tagb) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern double __nan (const char *__tagb) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int isnan (double __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern double j0 (double) __attribute__ ((__nothrow__ )); extern double __j0 (double) __attribute__ ((__nothrow__ ));
extern double j1 (double) __attribute__ ((__nothrow__ )); extern double __j1 (double) __attribute__ ((__nothrow__ ));
extern double jn (int, double) __attribute__ ((__nothrow__ )); extern double __jn (int, double) __attribute__ ((__nothrow__ ));
extern double y0 (double) __attribute__ ((__nothrow__ )); extern double __y0 (double) __attribute__ ((__nothrow__ ));
extern double y1 (double) __attribute__ ((__nothrow__ )); extern double __y1 (double) __attribute__ ((__nothrow__ ));
extern double yn (int, double) __attribute__ ((__nothrow__ )); extern double __yn (int, double) __attribute__ ((__nothrow__ ));
extern double erf (double) __attribute__ ((__nothrow__ )); extern double __erf (double) __attribute__ ((__nothrow__ ));
extern double erfc (double) __attribute__ ((__nothrow__ )); extern double __erfc (double) __attribute__ ((__nothrow__ ));
extern double lgamma (double) __attribute__ ((__nothrow__ )); extern double __lgamma (double) __attribute__ ((__nothrow__ ));
extern double tgamma (double) __attribute__ ((__nothrow__ )); extern double __tgamma (double) __attribute__ ((__nothrow__ ));
extern double gamma (double) __attribute__ ((__nothrow__ )); extern double __gamma (double) __attribute__ ((__nothrow__ ));
extern double lgamma_r (double, int *__signgamp) __attribute__ ((__nothrow__ )); extern double __lgamma_r (double, int *__signgamp) __attribute__ ((__nothrow__ ));
extern double rint (double __x) __attribute__ ((__nothrow__ )); extern double __rint (double __x) __attribute__ ((__nothrow__ ));
extern double nextafter (double __x, double __y) __attribute__ ((__nothrow__ )); extern double __nextafter (double __x, double __y) __attribute__ ((__nothrow__ ));
extern double nexttoward (double __x, long double __y) __attribute__ ((__nothrow__ )); extern double __nexttoward (double __x, long double __y) __attribute__ ((__nothrow__ ));
extern double remainder (double __x, double __y) __attribute__ ((__nothrow__ )); extern double __remainder (double __x, double __y) __attribute__ ((__nothrow__ ));
extern double scalbn (double __x, int __n) __attribute__ ((__nothrow__ )); extern double __scalbn (double __x, int __n) __attribute__ ((__nothrow__ ));
extern int ilogb (double __x) __attribute__ ((__nothrow__ )); extern int __ilogb (double __x) __attribute__ ((__nothrow__ ));
extern double scalbln (double __x, long int __n) __attribute__ ((__nothrow__ )); extern double __scalbln (double __x, long int __n) __attribute__ ((__nothrow__ ));
extern double nearbyint (double __x) __attribute__ ((__nothrow__ )); extern double __nearbyint (double __x) __attribute__ ((__nothrow__ ));
extern double round (double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern double __round (double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern double trunc (double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern double __trunc (double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern double remquo (double __x, double __y, int *__quo) __attribute__ ((__nothrow__ )); extern double __remquo (double __x, double __y, int *__quo) __attribute__ ((__nothrow__ ));
extern long int lrint (double __x) __attribute__ ((__nothrow__ )); extern long int __lrint (double __x) __attribute__ ((__nothrow__ ));
__extension__
extern long long int llrint (double __x) __attribute__ ((__nothrow__ )); extern long long int __llrint (double __x) __attribute__ ((__nothrow__ ));
extern long int lround (double __x) __attribute__ ((__nothrow__ )); extern long int __lround (double __x) __attribute__ ((__nothrow__ ));
__extension__
extern long long int llround (double __x) __attribute__ ((__nothrow__ )); extern long long int __llround (double __x) __attribute__ ((__nothrow__ ));
extern double fdim (double __x, double __y) __attribute__ ((__nothrow__ )); extern double __fdim (double __x, double __y) __attribute__ ((__nothrow__ ));
extern double fmax (double __x, double __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern double __fmax (double __x, double __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern double fmin (double __x, double __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern double __fmin (double __x, double __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern double fma (double __x, double __y, double __z) __attribute__ ((__nothrow__ )); extern double __fma (double __x, double __y, double __z) __attribute__ ((__nothrow__ ));
extern double scalb (double __x, double __n) __attribute__ ((__nothrow__ )); extern double __scalb (double __x, double __n) __attribute__ ((__nothrow__ ));
extern int __fpclassifyf (float __value) __attribute__ ((__nothrow__ ))
     __attribute__ ((__const__));
extern int __signbitf (float __value) __attribute__ ((__nothrow__ ))
     __attribute__ ((__const__));
extern int __isinff (float __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int __finitef (float __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int __isnanf (float __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int __iseqsigf (float __x, float __y) __attribute__ ((__nothrow__ ));
extern int __issignalingf (float __value) __attribute__ ((__nothrow__ ))
     __attribute__ ((__const__));
extern float acosf (float __x) __attribute__ ((__nothrow__ )); extern float __acosf (float __x) __attribute__ ((__nothrow__ ));
extern float asinf (float __x) __attribute__ ((__nothrow__ )); extern float __asinf (float __x) __attribute__ ((__nothrow__ ));
extern float atanf (float __x) __attribute__ ((__nothrow__ )); extern float __atanf (float __x) __attribute__ ((__nothrow__ ));
extern float atan2f (float __y, float __x) __attribute__ ((__nothrow__ )); extern float __atan2f (float __y, float __x) __attribute__ ((__nothrow__ ));
 extern float cosf (float __x) __attribute__ ((__nothrow__ )); extern float __cosf (float __x) __attribute__ ((__nothrow__ ));
 extern float sinf (float __x) __attribute__ ((__nothrow__ )); extern float __sinf (float __x) __attribute__ ((__nothrow__ ));
extern float tanf (float __x) __attribute__ ((__nothrow__ )); extern float __tanf (float __x) __attribute__ ((__nothrow__ ));
extern float coshf (float __x) __attribute__ ((__nothrow__ )); extern float __coshf (float __x) __attribute__ ((__nothrow__ ));
extern float sinhf (float __x) __attribute__ ((__nothrow__ )); extern float __sinhf (float __x) __attribute__ ((__nothrow__ ));
extern float tanhf (float __x) __attribute__ ((__nothrow__ )); extern float __tanhf (float __x) __attribute__ ((__nothrow__ ));
extern float acoshf (float __x) __attribute__ ((__nothrow__ )); extern float __acoshf (float __x) __attribute__ ((__nothrow__ ));
extern float asinhf (float __x) __attribute__ ((__nothrow__ )); extern float __asinhf (float __x) __attribute__ ((__nothrow__ ));
extern float atanhf (float __x) __attribute__ ((__nothrow__ )); extern float __atanhf (float __x) __attribute__ ((__nothrow__ ));
 extern float expf (float __x) __attribute__ ((__nothrow__ )); extern float __expf (float __x) __attribute__ ((__nothrow__ ));
extern float frexpf (float __x, int *__exponent) __attribute__ ((__nothrow__ )); extern float __frexpf (float __x, int *__exponent) __attribute__ ((__nothrow__ ));
extern float ldexpf (float __x, int __exponent) __attribute__ ((__nothrow__ )); extern float __ldexpf (float __x, int __exponent) __attribute__ ((__nothrow__ ));
 extern float logf (float __x) __attribute__ ((__nothrow__ )); extern float __logf (float __x) __attribute__ ((__nothrow__ ));
extern float log10f (float __x) __attribute__ ((__nothrow__ )); extern float __log10f (float __x) __attribute__ ((__nothrow__ ));
extern float modff (float __x, float *__iptr) __attribute__ ((__nothrow__ )); extern float __modff (float __x, float *__iptr) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern float expm1f (float __x) __attribute__ ((__nothrow__ )); extern float __expm1f (float __x) __attribute__ ((__nothrow__ ));
extern float log1pf (float __x) __attribute__ ((__nothrow__ )); extern float __log1pf (float __x) __attribute__ ((__nothrow__ ));
extern float logbf (float __x) __attribute__ ((__nothrow__ )); extern float __logbf (float __x) __attribute__ ((__nothrow__ ));
extern float exp2f (float __x) __attribute__ ((__nothrow__ )); extern float __exp2f (float __x) __attribute__ ((__nothrow__ ));
extern float log2f (float __x) __attribute__ ((__nothrow__ )); extern float __log2f (float __x) __attribute__ ((__nothrow__ ));
 extern float powf (float __x, float __y) __attribute__ ((__nothrow__ )); extern float __powf (float __x, float __y) __attribute__ ((__nothrow__ ));
extern float sqrtf (float __x) __attribute__ ((__nothrow__ )); extern float __sqrtf (float __x) __attribute__ ((__nothrow__ ));
extern float hypotf (float __x, float __y) __attribute__ ((__nothrow__ )); extern float __hypotf (float __x, float __y) __attribute__ ((__nothrow__ ));
extern float cbrtf (float __x) __attribute__ ((__nothrow__ )); extern float __cbrtf (float __x) __attribute__ ((__nothrow__ ));
extern float ceilf (float __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern float __ceilf (float __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern float fabsf (float __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern float __fabsf (float __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern float floorf (float __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern float __floorf (float __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern float fmodf (float __x, float __y) __attribute__ ((__nothrow__ )); extern float __fmodf (float __x, float __y) __attribute__ ((__nothrow__ ));
extern int isinff (float __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int finitef (float __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern float dremf (float __x, float __y) __attribute__ ((__nothrow__ )); extern float __dremf (float __x, float __y) __attribute__ ((__nothrow__ ));
extern float significandf (float __x) __attribute__ ((__nothrow__ )); extern float __significandf (float __x) __attribute__ ((__nothrow__ ));
extern float copysignf (float __x, float __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern float __copysignf (float __x, float __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern float nanf (const char *__tagb) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern float __nanf (const char *__tagb) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int isnanf (float __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern float j0f (float) __attribute__ ((__nothrow__ )); extern float __j0f (float) __attribute__ ((__nothrow__ ));
extern float j1f (float) __attribute__ ((__nothrow__ )); extern float __j1f (float) __attribute__ ((__nothrow__ ));
extern float jnf (int, float) __attribute__ ((__nothrow__ )); extern float __jnf (int, float) __attribute__ ((__nothrow__ ));
extern float y0f (float) __attribute__ ((__nothrow__ )); extern float __y0f (float) __attribute__ ((__nothrow__ ));
extern float y1f (float) __attribute__ ((__nothrow__ )); extern float __y1f (float) __attribute__ ((__nothrow__ ));
extern float ynf (int, float) __attribute__ ((__nothrow__ )); extern float __ynf (int, float) __attribute__ ((__nothrow__ ));
extern float erff (float) __attribute__ ((__nothrow__ )); extern float __erff (float) __attribute__ ((__nothrow__ ));
extern float erfcf (float) __attribute__ ((__nothrow__ )); extern float __erfcf (float) __attribute__ ((__nothrow__ ));
extern float lgammaf (float) __attribute__ ((__nothrow__ )); extern float __lgammaf (float) __attribute__ ((__nothrow__ ));
extern float tgammaf (float) __attribute__ ((__nothrow__ )); extern float __tgammaf (float) __attribute__ ((__nothrow__ ));
extern float gammaf (float) __attribute__ ((__nothrow__ )); extern float __gammaf (float) __attribute__ ((__nothrow__ ));
extern float lgammaf_r (float, int *__signgamp) __attribute__ ((__nothrow__ )); extern float __lgammaf_r (float, int *__signgamp) __attribute__ ((__nothrow__ ));
extern float rintf (float __x) __attribute__ ((__nothrow__ )); extern float __rintf (float __x) __attribute__ ((__nothrow__ ));
extern float nextafterf (float __x, float __y) __attribute__ ((__nothrow__ )); extern float __nextafterf (float __x, float __y) __attribute__ ((__nothrow__ ));
extern float nexttowardf (float __x, long double __y) __attribute__ ((__nothrow__ )); extern float __nexttowardf (float __x, long double __y) __attribute__ ((__nothrow__ ));
extern float remainderf (float __x, float __y) __attribute__ ((__nothrow__ )); extern float __remainderf (float __x, float __y) __attribute__ ((__nothrow__ ));
extern float scalbnf (float __x, int __n) __attribute__ ((__nothrow__ )); extern float __scalbnf (float __x, int __n) __attribute__ ((__nothrow__ ));
extern int ilogbf (float __x) __attribute__ ((__nothrow__ )); extern int __ilogbf (float __x) __attribute__ ((__nothrow__ ));
extern float scalblnf (float __x, long int __n) __attribute__ ((__nothrow__ )); extern float __scalblnf (float __x, long int __n) __attribute__ ((__nothrow__ ));
extern float nearbyintf (float __x) __attribute__ ((__nothrow__ )); extern float __nearbyintf (float __x) __attribute__ ((__nothrow__ ));
extern float roundf (float __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern float __roundf (float __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern float truncf (float __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern float __truncf (float __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern float remquof (float __x, float __y, int *__quo) __attribute__ ((__nothrow__ )); extern float __remquof (float __x, float __y, int *__quo) __attribute__ ((__nothrow__ ));
extern long int lrintf (float __x) __attribute__ ((__nothrow__ )); extern long int __lrintf (float __x) __attribute__ ((__nothrow__ ));
__extension__
extern long long int llrintf (float __x) __attribute__ ((__nothrow__ )); extern long long int __llrintf (float __x) __attribute__ ((__nothrow__ ));
extern long int lroundf (float __x) __attribute__ ((__nothrow__ )); extern long int __lroundf (float __x) __attribute__ ((__nothrow__ ));
__extension__
extern long long int llroundf (float __x) __attribute__ ((__nothrow__ )); extern long long int __llroundf (float __x) __attribute__ ((__nothrow__ ));
extern float fdimf (float __x, float __y) __attribute__ ((__nothrow__ )); extern float __fdimf (float __x, float __y) __attribute__ ((__nothrow__ ));
extern float fmaxf (float __x, float __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern float __fmaxf (float __x, float __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern float fminf (float __x, float __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern float __fminf (float __x, float __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern float fmaf (float __x, float __y, float __z) __attribute__ ((__nothrow__ )); extern float __fmaf (float __x, float __y, float __z) __attribute__ ((__nothrow__ ));
extern float scalbf (float __x, float __n) __attribute__ ((__nothrow__ )); extern float __scalbf (float __x, float __n) __attribute__ ((__nothrow__ ));
extern int __fpclassifyl (long double __value) __attribute__ ((__nothrow__ ))
     __attribute__ ((__const__));
extern int __signbitl (long double __value) __attribute__ ((__nothrow__ ))
     __attribute__ ((__const__));
extern int __isinfl (long double __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int __finitel (long double __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int __isnanl (long double __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int __iseqsigl (long double __x, long double __y) __attribute__ ((__nothrow__ ));
extern int __issignalingl (long double __value) __attribute__ ((__nothrow__ ))
     __attribute__ ((__const__));
extern long double acosl (long double __x) __attribute__ ((__nothrow__ )); extern long double __acosl (long double __x) __attribute__ ((__nothrow__ ));
extern long double asinl (long double __x) __attribute__ ((__nothrow__ )); extern long double __asinl (long double __x) __attribute__ ((__nothrow__ ));
extern long double atanl (long double __x) __attribute__ ((__nothrow__ )); extern long double __atanl (long double __x) __attribute__ ((__nothrow__ ));
extern long double atan2l (long double __y, long double __x) __attribute__ ((__nothrow__ )); extern long double __atan2l (long double __y, long double __x) __attribute__ ((__nothrow__ ));
 extern long double cosl (long double __x) __attribute__ ((__nothrow__ )); extern long double __cosl (long double __x) __attribute__ ((__nothrow__ ));
 extern long double sinl (long double __x) __attribute__ ((__nothrow__ )); extern long double __sinl (long double __x) __attribute__ ((__nothrow__ ));
extern long double tanl (long double __x) __attribute__ ((__nothrow__ )); extern long double __tanl (long double __x) __attribute__ ((__nothrow__ ));
extern long double coshl (long double __x) __attribute__ ((__nothrow__ )); extern long double __coshl (long double __x) __attribute__ ((__nothrow__ ));
extern long double sinhl (long double __x) __attribute__ ((__nothrow__ )); extern long double __sinhl (long double __x) __attribute__ ((__nothrow__ ));
extern long double tanhl (long double __x) __attribute__ ((__nothrow__ )); extern long double __tanhl (long double __x) __attribute__ ((__nothrow__ ));
extern long double acoshl (long double __x) __attribute__ ((__nothrow__ )); extern long double __acoshl (long double __x) __attribute__ ((__nothrow__ ));
extern long double asinhl (long double __x) __attribute__ ((__nothrow__ )); extern long double __asinhl (long double __x) __attribute__ ((__nothrow__ ));
extern long double atanhl (long double __x) __attribute__ ((__nothrow__ )); extern long double __atanhl (long double __x) __attribute__ ((__nothrow__ ));
 extern long double expl (long double __x) __attribute__ ((__nothrow__ )); extern long double __expl (long double __x) __attribute__ ((__nothrow__ ));
extern long double frexpl (long double __x, int *__exponent) __attribute__ ((__nothrow__ )); extern long double __frexpl (long double __x, int *__exponent) __attribute__ ((__nothrow__ ));
extern long double ldexpl (long double __x, int __exponent) __attribute__ ((__nothrow__ )); extern long double __ldexpl (long double __x, int __exponent) __attribute__ ((__nothrow__ ));
 extern long double logl (long double __x) __attribute__ ((__nothrow__ )); extern long double __logl (long double __x) __attribute__ ((__nothrow__ ));
extern long double log10l (long double __x) __attribute__ ((__nothrow__ )); extern long double __log10l (long double __x) __attribute__ ((__nothrow__ ));
extern long double modfl (long double __x, long double *__iptr) __attribute__ ((__nothrow__ )); extern long double __modfl (long double __x, long double *__iptr) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern long double expm1l (long double __x) __attribute__ ((__nothrow__ )); extern long double __expm1l (long double __x) __attribute__ ((__nothrow__ ));
extern long double log1pl (long double __x) __attribute__ ((__nothrow__ )); extern long double __log1pl (long double __x) __attribute__ ((__nothrow__ ));
extern long double logbl (long double __x) __attribute__ ((__nothrow__ )); extern long double __logbl (long double __x) __attribute__ ((__nothrow__ ));
extern long double exp2l (long double __x) __attribute__ ((__nothrow__ )); extern long double __exp2l (long double __x) __attribute__ ((__nothrow__ ));
extern long double log2l (long double __x) __attribute__ ((__nothrow__ )); extern long double __log2l (long double __x) __attribute__ ((__nothrow__ ));
 extern long double powl (long double __x, long double __y) __attribute__ ((__nothrow__ )); extern long double __powl (long double __x, long double __y) __attribute__ ((__nothrow__ ));
extern long double sqrtl (long double __x) __attribute__ ((__nothrow__ )); extern long double __sqrtl (long double __x) __attribute__ ((__nothrow__ ));
extern long double hypotl (long double __x, long double __y) __attribute__ ((__nothrow__ )); extern long double __hypotl (long double __x, long double __y) __attribute__ ((__nothrow__ ));
extern long double cbrtl (long double __x) __attribute__ ((__nothrow__ )); extern long double __cbrtl (long double __x) __attribute__ ((__nothrow__ ));
extern long double ceill (long double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern long double __ceill (long double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern long double fabsl (long double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern long double __fabsl (long double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern long double floorl (long double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern long double __floorl (long double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern long double fmodl (long double __x, long double __y) __attribute__ ((__nothrow__ )); extern long double __fmodl (long double __x, long double __y) __attribute__ ((__nothrow__ ));
extern int isinfl (long double __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int finitel (long double __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern long double dreml (long double __x, long double __y) __attribute__ ((__nothrow__ )); extern long double __dreml (long double __x, long double __y) __attribute__ ((__nothrow__ ));
extern long double significandl (long double __x) __attribute__ ((__nothrow__ )); extern long double __significandl (long double __x) __attribute__ ((__nothrow__ ));
extern long double copysignl (long double __x, long double __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern long double __copysignl (long double __x, long double __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern long double nanl (const char *__tagb) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern long double __nanl (const char *__tagb) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int isnanl (long double __value) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern long double j0l (long double) __attribute__ ((__nothrow__ )); extern long double __j0l (long double) __attribute__ ((__nothrow__ ));
extern long double j1l (long double) __attribute__ ((__nothrow__ )); extern long double __j1l (long double) __attribute__ ((__nothrow__ ));
extern long double jnl (int, long double) __attribute__ ((__nothrow__ )); extern long double __jnl (int, long double) __attribute__ ((__nothrow__ ));
extern long double y0l (long double) __attribute__ ((__nothrow__ )); extern long double __y0l (long double) __attribute__ ((__nothrow__ ));
extern long double y1l (long double) __attribute__ ((__nothrow__ )); extern long double __y1l (long double) __attribute__ ((__nothrow__ ));
extern long double ynl (int, long double) __attribute__ ((__nothrow__ )); extern long double __ynl (int, long double) __attribute__ ((__nothrow__ ));
extern long double erfl (long double) __attribute__ ((__nothrow__ )); extern long double __erfl (long double) __attribute__ ((__nothrow__ ));
extern long double erfcl (long double) __attribute__ ((__nothrow__ )); extern long double __erfcl (long double) __attribute__ ((__nothrow__ ));
extern long double lgammal (long double) __attribute__ ((__nothrow__ )); extern long double __lgammal (long double) __attribute__ ((__nothrow__ ));
extern long double tgammal (long double) __attribute__ ((__nothrow__ )); extern long double __tgammal (long double) __attribute__ ((__nothrow__ ));
extern long double gammal (long double) __attribute__ ((__nothrow__ )); extern long double __gammal (long double) __attribute__ ((__nothrow__ ));
extern long double lgammal_r (long double, int *__signgamp) __attribute__ ((__nothrow__ )); extern long double __lgammal_r (long double, int *__signgamp) __attribute__ ((__nothrow__ ));
extern long double rintl (long double __x) __attribute__ ((__nothrow__ )); extern long double __rintl (long double __x) __attribute__ ((__nothrow__ ));
extern long double nextafterl (long double __x, long double __y) __attribute__ ((__nothrow__ )); extern long double __nextafterl (long double __x, long double __y) __attribute__ ((__nothrow__ ));
extern long double nexttowardl (long double __x, long double __y) __attribute__ ((__nothrow__ )); extern long double __nexttowardl (long double __x, long double __y) __attribute__ ((__nothrow__ ));
extern long double remainderl (long double __x, long double __y) __attribute__ ((__nothrow__ )); extern long double __remainderl (long double __x, long double __y) __attribute__ ((__nothrow__ ));
extern long double scalbnl (long double __x, int __n) __attribute__ ((__nothrow__ )); extern long double __scalbnl (long double __x, int __n) __attribute__ ((__nothrow__ ));
extern int ilogbl (long double __x) __attribute__ ((__nothrow__ )); extern int __ilogbl (long double __x) __attribute__ ((__nothrow__ ));
extern long double scalblnl (long double __x, long int __n) __attribute__ ((__nothrow__ )); extern long double __scalblnl (long double __x, long int __n) __attribute__ ((__nothrow__ ));
extern long double nearbyintl (long double __x) __attribute__ ((__nothrow__ )); extern long double __nearbyintl (long double __x) __attribute__ ((__nothrow__ ));
extern long double roundl (long double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern long double __roundl (long double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern long double truncl (long double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern long double __truncl (long double __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern long double remquol (long double __x, long double __y, int *__quo) __attribute__ ((__nothrow__ )); extern long double __remquol (long double __x, long double __y, int *__quo) __attribute__ ((__nothrow__ ));
extern long int lrintl (long double __x) __attribute__ ((__nothrow__ )); extern long int __lrintl (long double __x) __attribute__ ((__nothrow__ ));
__extension__
extern long long int llrintl (long double __x) __attribute__ ((__nothrow__ )); extern long long int __llrintl (long double __x) __attribute__ ((__nothrow__ ));
extern long int lroundl (long double __x) __attribute__ ((__nothrow__ )); extern long int __lroundl (long double __x) __attribute__ ((__nothrow__ ));
__extension__
extern long long int llroundl (long double __x) __attribute__ ((__nothrow__ )); extern long long int __llroundl (long double __x) __attribute__ ((__nothrow__ ));
extern long double fdiml (long double __x, long double __y) __attribute__ ((__nothrow__ )); extern long double __fdiml (long double __x, long double __y) __attribute__ ((__nothrow__ ));
extern long double fmaxl (long double __x, long double __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern long double __fmaxl (long double __x, long double __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern long double fminl (long double __x, long double __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)); extern long double __fminl (long double __x, long double __y) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern long double fmal (long double __x, long double __y, long double __z) __attribute__ ((__nothrow__ )); extern long double __fmal (long double __x, long double __y, long double __z) __attribute__ ((__nothrow__ ));
extern long double scalbl (long double __x, long double __n) __attribute__ ((__nothrow__ )); extern long double __scalbl (long double __x, long double __n) __attribute__ ((__nothrow__ ));
extern int signgam;
enum
  {
    FP_NAN =
      0,
    FP_INFINITE =
      1,
    FP_ZERO =
      2,
    FP_SUBNORMAL =
      3,
    FP_NORMAL =
      4
  };
struct list_head {
 struct list_head * next, * prev;
};
static void init_list_head(struct list_head * list)
;
static void __list_add(struct list_head * new,
         struct list_head * prev,
         struct list_head * next)
;
static void list_add(struct list_head * new, struct list_head * head)
;
static void list_add_tail(struct list_head * new, struct list_head * head)
;
static void __list_del(struct list_head * prev, struct list_head * next)
;
static void __list_del_entry(struct list_head * entry)
;
static void list_del(struct list_head *entry)
;
static void list_replace(struct list_head * old,
    struct list_head * new)
;
static void list_replace_init(struct list_head * old,
     struct list_head * new)
;
static void list_del_init(struct list_head * entry)
;
static void list_move(struct list_head * list, struct list_head * head)
;
static void list_move_tail(struct list_head * list,
      struct list_head * head)
;
static void list_bulk_move_tail(struct list_head * head,
           struct list_head * first,
           struct list_head * last)
;
static int list_is_first(const struct list_head * list,
    const struct list_head * head)
;
static int list_is_last(const struct list_head * list,
    const struct list_head * head)
;
static int list_empty(const struct list_head * head)
;
static int list_empty_careful(const struct list_head * head)
;
static void list_rotate_left(struct list_head * head)
;
static int list_is_singular(const struct list_head * head)
;
static void __list_cut_position(struct list_head * list,
  struct list_head * head, struct list_head * entry)
;
static void list_cut_position(struct list_head * list,
  struct list_head * head, struct list_head * entry)
;
static void list_cut_before(struct list_head * list,
       struct list_head * head,
       struct list_head * entry)
;
static void __list_splice(const struct list_head * list,
     struct list_head * prev,
     struct list_head * next)
;
static void list_splice(const struct list_head * list,
    struct list_head * head)
;
static void list_splice_tail(struct list_head * list,
    struct list_head * head)
;
static void list_splice_init(struct list_head * list,
        struct list_head * head)
;
static void list_splice_tail_init(struct list_head * list,
      struct list_head * head)
;
struct hlist_head {
 struct hlist_node * first;
};
struct hlist_node {
 struct hlist_node * next, ** pprev;
};
static void init_hlist_head(struct hlist_head * hlist)
;
static void init_hlist_node(struct hlist_node * h)
;
static int hlist_unhashed(const struct hlist_node * h)
;
static int hlist_empty(const struct hlist_head * h)
;
static void __hlist_del(struct hlist_node * n)
;
static void hlist_del(struct hlist_node * n)
;
static void hlist_del_init(struct hlist_node * n)
;
static void hlist_add_head(struct hlist_node * n, struct hlist_head * h)
;
static void hlist_add_before(struct hlist_node * n,
     struct hlist_node * next)
;
static void hlist_add_behind(struct hlist_node * n,
        struct hlist_node * prev)
;
static void hlist_add_fake(struct hlist_node * n)
;
static int hlist_fake(struct hlist_node * h)
;
static int hlist_is_singular_node(struct hlist_node * n, struct hlist_head * h)
;
static void hlist_move_list(struct hlist_head * old,
       struct hlist_head * new)
;
struct hmap_t {
 struct hlist_head * hash;
 struct list_head list;
 unsigned int size;
 unsigned int n;
};
struct hmap_entry_t {
 struct hlist_node node;
 struct list_head head;
 char * key;
 void * value;
};
struct hmap_t * hmap_alloc(unsigned int size);
void hmap_free(struct hmap_t * m, void (*cb)(struct hmap_entry_t *));
void hmap_clear(struct hmap_t * m, void (*cb)(struct hmap_entry_t *));
void hmap_add(struct hmap_t * m, const char * key, void * value);
void hmap_remove(struct hmap_t * m, const char * key);
void hmap_sort(struct hmap_t * m);
void * hmap_search(struct hmap_t * m, const char * key);
static uint16_t __swab16(uint16_t x)
;
static uint32_t __swab32(uint32_t x)
;
static uint64_t __swab64(uint64_t x)
;
static uint32_t __swahw32(uint32_t x)
;
static uint32_t __swahb32(uint32_t x)
;
static uint16_t float32_to_float16(float v)
;
static float float16_to_float32(uint16_t v)
;
static uint16_t float32_to_bfloat16(float v)
;
static float bfloat16_to_float32(uint16_t v)
;
static uint32_t shash(const char * s)
;
extern void __assert_fail (const char *__assertion, const char *__file,
      unsigned int __line, const char *__function)
     __attribute__ ((__nothrow__ )) __attribute__ ((__noreturn__));
extern void __assert_perror_fail (int __errnum, const char *__file,
      unsigned int __line, const char *__function)
     __attribute__ ((__nothrow__ )) __attribute__ ((__noreturn__));
extern void __assert (const char *__assertion, const char *__file, int __line)
     __attribute__ ((__nothrow__ )) __attribute__ ((__noreturn__));
extern const char protobuf_c_empty_string[];
typedef enum {
 PROTOBUF_C_FIELD_FLAG_PACKED = (1 << 0),
 PROTOBUF_C_FIELD_FLAG_DEPRECATED = (1 << 1),
 PROTOBUF_C_FIELD_FLAG_ONEOF = (1 << 2),
} ProtobufCFieldFlag;
typedef enum {
 PROTOBUF_C_LABEL_REQUIRED,
 PROTOBUF_C_LABEL_OPTIONAL,
 PROTOBUF_C_LABEL_REPEATED,
 PROTOBUF_C_LABEL_NONE,
} ProtobufCLabel;
typedef enum {
 PROTOBUF_C_TYPE_INT32,
 PROTOBUF_C_TYPE_SINT32,
 PROTOBUF_C_TYPE_SFIXED32,
 PROTOBUF_C_TYPE_INT64,
 PROTOBUF_C_TYPE_SINT64,
 PROTOBUF_C_TYPE_SFIXED64,
 PROTOBUF_C_TYPE_UINT32,
 PROTOBUF_C_TYPE_FIXED32,
 PROTOBUF_C_TYPE_UINT64,
 PROTOBUF_C_TYPE_FIXED64,
 PROTOBUF_C_TYPE_FLOAT,
 PROTOBUF_C_TYPE_DOUBLE,
 PROTOBUF_C_TYPE_BOOL,
 PROTOBUF_C_TYPE_ENUM,
 PROTOBUF_C_TYPE_STRING,
 PROTOBUF_C_TYPE_BYTES,
 PROTOBUF_C_TYPE_MESSAGE,
} ProtobufCType;
typedef enum {
 PROTOBUF_C_WIRE_TYPE_VARINT = 0,
 PROTOBUF_C_WIRE_TYPE_64BIT = 1,
 PROTOBUF_C_WIRE_TYPE_LENGTH_PREFIXED = 2,
 PROTOBUF_C_WIRE_TYPE_32BIT = 5,
} ProtobufCWireType;
struct ProtobufCAllocator;
struct ProtobufCBinaryData;
struct ProtobufCBuffer;
struct ProtobufCBufferSimple;
struct ProtobufCEnumDescriptor;
struct ProtobufCEnumValue;
struct ProtobufCEnumValueIndex;
struct ProtobufCFieldDescriptor;
struct ProtobufCIntRange;
struct ProtobufCMessage;
struct ProtobufCMessageDescriptor;
struct ProtobufCMessageUnknownField;
struct ProtobufCMethodDescriptor;
struct ProtobufCService;
struct ProtobufCServiceDescriptor;
typedef struct ProtobufCAllocator ProtobufCAllocator;
typedef struct ProtobufCBinaryData ProtobufCBinaryData;
typedef struct ProtobufCBuffer ProtobufCBuffer;
typedef struct ProtobufCBufferSimple ProtobufCBufferSimple;
typedef struct ProtobufCEnumDescriptor ProtobufCEnumDescriptor;
typedef struct ProtobufCEnumValue ProtobufCEnumValue;
typedef struct ProtobufCEnumValueIndex ProtobufCEnumValueIndex;
typedef struct ProtobufCFieldDescriptor ProtobufCFieldDescriptor;
typedef struct ProtobufCIntRange ProtobufCIntRange;
typedef struct ProtobufCMessage ProtobufCMessage;
typedef struct ProtobufCMessageDescriptor ProtobufCMessageDescriptor;
typedef struct ProtobufCMessageUnknownField ProtobufCMessageUnknownField;
typedef struct ProtobufCMethodDescriptor ProtobufCMethodDescriptor;
typedef struct ProtobufCService ProtobufCService;
typedef struct ProtobufCServiceDescriptor ProtobufCServiceDescriptor;
typedef int protobuf_c_boolean;
typedef void (*ProtobufCClosure)(const ProtobufCMessage *, void *closure_data);
typedef void (*ProtobufCMessageInit)(ProtobufCMessage *);
typedef void (*ProtobufCServiceDestroy)(ProtobufCService *);
struct ProtobufCAllocator {
 void *(*alloc)(void *allocator_data, size_t size);
 void (*free)(void *allocator_data, void *pointer);
 void *allocator_data;
};
struct ProtobufCBinaryData {
 size_t len;
 uint8_t *data;
};
struct ProtobufCBuffer {
 void (*append)(ProtobufCBuffer *buffer,
      size_t len,
      const uint8_t *data);
};
struct ProtobufCBufferSimple {
 ProtobufCBuffer base;
 size_t alloced;
 size_t len;
 uint8_t *data;
 protobuf_c_boolean must_free_data;
 ProtobufCAllocator *allocator;
};
struct ProtobufCEnumDescriptor {
 uint32_t magic;
 const char *name;
 const char *short_name;
 const char *c_name;
 const char *package_name;
 unsigned n_values;
 const ProtobufCEnumValue *values;
 unsigned n_value_names;
 const ProtobufCEnumValueIndex *values_by_name;
 unsigned n_value_ranges;
 const ProtobufCIntRange *value_ranges;
 void *reserved1;
 void *reserved2;
 void *reserved3;
 void *reserved4;
};
struct ProtobufCEnumValue {
 const char *name;
 const char *c_name;
 int value;
};
struct ProtobufCEnumValueIndex {
 const char *name;
 unsigned index;
};
struct ProtobufCFieldDescriptor {
 const char *name;
 uint32_t id;
 ProtobufCLabel label;
 ProtobufCType type;
 unsigned quantifier_offset;
 unsigned offset;
 const void *descriptor;
 const void *default_value;
 uint32_t flags;
 unsigned reserved_flags;
 void *reserved2;
 void *reserved3;
};
struct ProtobufCIntRange {
 int start_value;
 unsigned orig_index;
};
struct ProtobufCMessage {
 const ProtobufCMessageDescriptor *descriptor;
 unsigned n_unknown_fields;
 ProtobufCMessageUnknownField *unknown_fields;
};
struct ProtobufCMessageDescriptor {
 uint32_t magic;
 const char *name;
 const char *short_name;
 const char *c_name;
 const char *package_name;
 size_t sizeof_message;
 unsigned n_fields;
 const ProtobufCFieldDescriptor *fields;
 const unsigned *fields_sorted_by_name;
 unsigned n_field_ranges;
 const ProtobufCIntRange *field_ranges;
 ProtobufCMessageInit message_init;
 void *reserved1;
 void *reserved2;
 void *reserved3;
};
struct ProtobufCMessageUnknownField {
 uint32_t tag;
 ProtobufCWireType wire_type;
 size_t len;
 uint8_t *data;
};
struct ProtobufCMethodDescriptor {
 const char *name;
 const ProtobufCMessageDescriptor *input;
 const ProtobufCMessageDescriptor *output;
};
struct ProtobufCService {
 const ProtobufCServiceDescriptor *descriptor;
 void (*invoke)(ProtobufCService *service,
         unsigned method_index,
         const ProtobufCMessage *input,
         ProtobufCClosure closure,
         void *closure_data);
 void (*destroy)(ProtobufCService *service);
};
struct ProtobufCServiceDescriptor {
 uint32_t magic;
 const char *name;
 const char *short_name;
 const char *c_name;
 const char *package;
 unsigned n_methods;
 const ProtobufCMethodDescriptor *methods;
 const unsigned *method_indices_by_name;
};
const char *
protobuf_c_version(void);
uint32_t
protobuf_c_version_number(void);
const ProtobufCEnumValue *
protobuf_c_enum_descriptor_get_value_by_name(
 const ProtobufCEnumDescriptor *desc,
 const char *name);
const ProtobufCEnumValue *
protobuf_c_enum_descriptor_get_value(
 const ProtobufCEnumDescriptor *desc,
 int value);
const ProtobufCFieldDescriptor *
protobuf_c_message_descriptor_get_field_by_name(
 const ProtobufCMessageDescriptor *desc,
 const char *name);
const ProtobufCFieldDescriptor *
protobuf_c_message_descriptor_get_field(
 const ProtobufCMessageDescriptor *desc,
 unsigned value);
size_t
protobuf_c_message_get_packed_size(const ProtobufCMessage *message);
size_t
protobuf_c_message_pack(const ProtobufCMessage *message, uint8_t *out);
size_t
protobuf_c_message_pack_to_buffer(
 const ProtobufCMessage *message,
 ProtobufCBuffer *buffer);
ProtobufCMessage *
protobuf_c_message_unpack(
 const ProtobufCMessageDescriptor *descriptor,
 ProtobufCAllocator *allocator,
 size_t len,
 const uint8_t *data);
void
protobuf_c_message_free_unpacked(
 ProtobufCMessage *message,
 ProtobufCAllocator *allocator);
protobuf_c_boolean
protobuf_c_message_check(const ProtobufCMessage *);
void
protobuf_c_message_init(
 const ProtobufCMessageDescriptor *descriptor,
 void *message);
void
protobuf_c_service_destroy(ProtobufCService *service);
const ProtobufCMethodDescriptor *
protobuf_c_service_descriptor_get_method_by_name(
 const ProtobufCServiceDescriptor *desc,
 const char *name);
void
protobuf_c_buffer_simple_append(
 ProtobufCBuffer *buffer,
 size_t len,
 const unsigned char *data);
void
protobuf_c_service_generated_init(
 ProtobufCService *service,
 const ProtobufCServiceDescriptor *descriptor,
 ProtobufCServiceDestroy destroy);
void
protobuf_c_service_invoke_internal(
 ProtobufCService *service,
 unsigned method_index,
 const ProtobufCMessage *input,
 ProtobufCClosure closure,
 void *closure_data);
typedef struct Onnx__AttributeProto Onnx__AttributeProto;
typedef struct Onnx__ValueInfoProto Onnx__ValueInfoProto;
typedef struct Onnx__NodeProto Onnx__NodeProto;
typedef struct Onnx__TrainingInfoProto Onnx__TrainingInfoProto;
typedef struct Onnx__ModelProto Onnx__ModelProto;
typedef struct Onnx__StringStringEntryProto Onnx__StringStringEntryProto;
typedef struct Onnx__TensorAnnotation Onnx__TensorAnnotation;
typedef struct Onnx__GraphProto Onnx__GraphProto;
typedef struct Onnx__TensorProto Onnx__TensorProto;
typedef struct Onnx__TensorProto__Segment Onnx__TensorProto__Segment;
typedef struct Onnx__SparseTensorProto Onnx__SparseTensorProto;
typedef struct Onnx__TensorShapeProto Onnx__TensorShapeProto;
typedef struct Onnx__TensorShapeProto__Dimension Onnx__TensorShapeProto__Dimension;
typedef struct Onnx__TypeProto Onnx__TypeProto;
typedef struct Onnx__TypeProto__Tensor Onnx__TypeProto__Tensor;
typedef struct Onnx__TypeProto__Sequence Onnx__TypeProto__Sequence;
typedef struct Onnx__TypeProto__Map Onnx__TypeProto__Map;
typedef struct Onnx__OperatorSetIdProto Onnx__OperatorSetIdProto;
typedef enum _Onnx__AttributeProto__AttributeType {
  ONNX__ATTRIBUTE_PROTO__ATTRIBUTE_TYPE__UNDEFINED = 0,
  ONNX__ATTRIBUTE_PROTO__ATTRIBUTE_TYPE__FLOAT = 1,
  ONNX__ATTRIBUTE_PROTO__ATTRIBUTE_TYPE__INT = 2,
  ONNX__ATTRIBUTE_PROTO__ATTRIBUTE_TYPE__STRING = 3,
  ONNX__ATTRIBUTE_PROTO__ATTRIBUTE_TYPE__TENSOR = 4,
  ONNX__ATTRIBUTE_PROTO__ATTRIBUTE_TYPE__GRAPH = 5,
  ONNX__ATTRIBUTE_PROTO__ATTRIBUTE_TYPE__SPARSE_TENSOR = 11,
  ONNX__ATTRIBUTE_PROTO__ATTRIBUTE_TYPE__FLOATS = 6,
  ONNX__ATTRIBUTE_PROTO__ATTRIBUTE_TYPE__INTS = 7,
  ONNX__ATTRIBUTE_PROTO__ATTRIBUTE_TYPE__STRINGS = 8,
  ONNX__ATTRIBUTE_PROTO__ATTRIBUTE_TYPE__TENSORS = 9,
  ONNX__ATTRIBUTE_PROTO__ATTRIBUTE_TYPE__GRAPHS = 10,
  ONNX__ATTRIBUTE_PROTO__ATTRIBUTE_TYPE__SPARSE_TENSORS = 12
    , _ONNX__ATTRIBUTE_PROTO__ATTRIBUTE_TYPE_IS_INT_SIZE = 2147483647
} Onnx__AttributeProto__AttributeType;
typedef enum _Onnx__TensorProto__DataType {
  ONNX__TENSOR_PROTO__DATA_TYPE__UNDEFINED = 0,
  ONNX__TENSOR_PROTO__DATA_TYPE__FLOAT = 1,
  ONNX__TENSOR_PROTO__DATA_TYPE__UINT8 = 2,
  ONNX__TENSOR_PROTO__DATA_TYPE__INT8 = 3,
  ONNX__TENSOR_PROTO__DATA_TYPE__UINT16 = 4,
  ONNX__TENSOR_PROTO__DATA_TYPE__INT16 = 5,
  ONNX__TENSOR_PROTO__DATA_TYPE__INT32 = 6,
  ONNX__TENSOR_PROTO__DATA_TYPE__INT64 = 7,
  ONNX__TENSOR_PROTO__DATA_TYPE__STRING = 8,
  ONNX__TENSOR_PROTO__DATA_TYPE__BOOL = 9,
  ONNX__TENSOR_PROTO__DATA_TYPE__FLOAT16 = 10,
  ONNX__TENSOR_PROTO__DATA_TYPE__DOUBLE = 11,
  ONNX__TENSOR_PROTO__DATA_TYPE__UINT32 = 12,
  ONNX__TENSOR_PROTO__DATA_TYPE__UINT64 = 13,
  ONNX__TENSOR_PROTO__DATA_TYPE__COMPLEX64 = 14,
  ONNX__TENSOR_PROTO__DATA_TYPE__COMPLEX128 = 15,
  ONNX__TENSOR_PROTO__DATA_TYPE__BFLOAT16 = 16
    , _ONNX__TENSOR_PROTO__DATA_TYPE_IS_INT_SIZE = 2147483647
} Onnx__TensorProto__DataType;
typedef enum _Onnx__TensorProto__DataLocation {
  ONNX__TENSOR_PROTO__DATA_LOCATION__DEFAULT = 0,
  ONNX__TENSOR_PROTO__DATA_LOCATION__EXTERNAL = 1
    , _ONNX__TENSOR_PROTO__DATA_LOCATION_IS_INT_SIZE = 2147483647
} Onnx__TensorProto__DataLocation;
typedef enum _Onnx__Version {
  ONNX__VERSION___START_VERSION = 0,
  ONNX__VERSION__IR_VERSION_2017_10_10 = 1,
  ONNX__VERSION__IR_VERSION_2017_10_30 = 2,
  ONNX__VERSION__IR_VERSION_2017_11_3 = 3,
  ONNX__VERSION__IR_VERSION_2019_1_22 = 4,
  ONNX__VERSION__IR_VERSION_2019_3_18 = 5,
  ONNX__VERSION__IR_VERSION_2019_9_19 = 6,
  ONNX__VERSION__IR_VERSION = 7
    , _ONNX__VERSION_IS_INT_SIZE = 2147483647
} Onnx__Version;
struct Onnx__AttributeProto
{
  ProtobufCMessage base;
  char *name;
  char *ref_attr_name;
  char *doc_string;
  Onnx__AttributeProto__AttributeType type;
  float f;
  int64_t i;
  ProtobufCBinaryData s;
  Onnx__TensorProto *t;
  Onnx__GraphProto *g;
  Onnx__SparseTensorProto *sparse_tensor;
  size_t n_floats;
  float *floats;
  size_t n_ints;
  int64_t *ints;
  size_t n_strings;
  ProtobufCBinaryData *strings;
  size_t n_tensors;
  Onnx__TensorProto **tensors;
  size_t n_graphs;
  Onnx__GraphProto **graphs;
  size_t n_sparse_tensors;
  Onnx__SparseTensorProto **sparse_tensors;
};
struct Onnx__ValueInfoProto
{
  ProtobufCMessage base;
  char *name;
  Onnx__TypeProto *type;
  char *doc_string;
};
struct Onnx__NodeProto
{
  ProtobufCMessage base;
  size_t n_input;
  char **input;
  size_t n_output;
  char **output;
  char *name;
  char *op_type;
  char *domain;
  size_t n_attribute;
  Onnx__AttributeProto **attribute;
  char *doc_string;
};
struct Onnx__TrainingInfoProto
{
  ProtobufCMessage base;
  Onnx__GraphProto *initialization;
  Onnx__GraphProto *algorithm;
  size_t n_initialization_binding;
  Onnx__StringStringEntryProto **initialization_binding;
  size_t n_update_binding;
  Onnx__StringStringEntryProto **update_binding;
};
struct Onnx__ModelProto
{
  ProtobufCMessage base;
  int64_t ir_version;
  size_t n_opset_import;
  Onnx__OperatorSetIdProto **opset_import;
  char *producer_name;
  char *producer_version;
  char *domain;
  int64_t model_version;
  char *doc_string;
  Onnx__GraphProto *graph;
  size_t n_metadata_props;
  Onnx__StringStringEntryProto **metadata_props;
  size_t n_training_info;
  Onnx__TrainingInfoProto **training_info;
};
struct Onnx__StringStringEntryProto
{
  ProtobufCMessage base;
  char *key;
  char *value;
};
struct Onnx__TensorAnnotation
{
  ProtobufCMessage base;
  char *tensor_name;
  size_t n_quant_parameter_tensor_names;
  Onnx__StringStringEntryProto **quant_parameter_tensor_names;
};
struct Onnx__GraphProto
{
  ProtobufCMessage base;
  size_t n_node;
  Onnx__NodeProto **node;
  char *name;
  size_t n_initializer;
  Onnx__TensorProto **initializer;
  size_t n_sparse_initializer;
  Onnx__SparseTensorProto **sparse_initializer;
  char *doc_string;
  size_t n_input;
  Onnx__ValueInfoProto **input;
  size_t n_output;
  Onnx__ValueInfoProto **output;
  size_t n_value_info;
  Onnx__ValueInfoProto **value_info;
  size_t n_quantization_annotation;
  Onnx__TensorAnnotation **quantization_annotation;
};
struct Onnx__TensorProto__Segment
{
  ProtobufCMessage base;
  int64_t begin;
  int64_t end;
};
struct Onnx__TensorProto
{
  ProtobufCMessage base;
  size_t n_dims;
  int64_t *dims;
  int32_t data_type;
  Onnx__TensorProto__Segment *segment;
  size_t n_float_data;
  float *float_data;
  size_t n_int32_data;
  int32_t *int32_data;
  size_t n_string_data;
  ProtobufCBinaryData *string_data;
  size_t n_int64_data;
  int64_t *int64_data;
  char *name;
  char *doc_string;
  ProtobufCBinaryData raw_data;
  size_t n_external_data;
  Onnx__StringStringEntryProto **external_data;
  Onnx__TensorProto__DataLocation data_location;
  size_t n_double_data;
  double *double_data;
  size_t n_uint64_data;
  uint64_t *uint64_data;
};
struct Onnx__SparseTensorProto
{
  ProtobufCMessage base;
  Onnx__TensorProto *values;
  Onnx__TensorProto *indices;
  size_t n_dims;
  int64_t *dims;
};
typedef enum {
  ONNX__TENSOR_SHAPE_PROTO__DIMENSION__VALUE__NOT_SET = 0,
  ONNX__TENSOR_SHAPE_PROTO__DIMENSION__VALUE_DIM_VALUE = 1,
  ONNX__TENSOR_SHAPE_PROTO__DIMENSION__VALUE_DIM_PARAM = 2
    , _ONNX__TENSOR_SHAPE_PROTO__DIMENSION__VALUE__CASE_IS_INT_SIZE = 2147483647
} Onnx__TensorShapeProto__Dimension__ValueCase;
struct Onnx__TensorShapeProto__Dimension
{
  ProtobufCMessage base;
  char *denotation;
  Onnx__TensorShapeProto__Dimension__ValueCase value_case;
  union {
    int64_t dim_value;
    char *dim_param;
  };
};
struct Onnx__TensorShapeProto
{
  ProtobufCMessage base;
  size_t n_dim;
  Onnx__TensorShapeProto__Dimension **dim;
};
struct Onnx__TypeProto__Tensor
{
  ProtobufCMessage base;
  int32_t elem_type;
  Onnx__TensorShapeProto *shape;
};
struct Onnx__TypeProto__Sequence
{
  ProtobufCMessage base;
  Onnx__TypeProto *elem_type;
};
struct Onnx__TypeProto__Map
{
  ProtobufCMessage base;
  int32_t key_type;
  Onnx__TypeProto *value_type;
};
typedef enum {
  ONNX__TYPE_PROTO__VALUE__NOT_SET = 0,
  ONNX__TYPE_PROTO__VALUE_TENSOR_TYPE = 1,
  ONNX__TYPE_PROTO__VALUE_SEQUENCE_TYPE = 4,
  ONNX__TYPE_PROTO__VALUE_MAP_TYPE = 5
    , _ONNX__TYPE_PROTO__VALUE__CASE_IS_INT_SIZE = 2147483647
} Onnx__TypeProto__ValueCase;
struct Onnx__TypeProto
{
  ProtobufCMessage base;
  char *denotation;
  Onnx__TypeProto__ValueCase value_case;
  union {
    Onnx__TypeProto__Tensor *tensor_type;
    Onnx__TypeProto__Sequence *sequence_type;
    Onnx__TypeProto__Map *map_type;
  };
};
struct Onnx__OperatorSetIdProto
{
  ProtobufCMessage base;
  char *domain;
  int64_t version;
};
void onnx__attribute_proto__init
                     (Onnx__AttributeProto *message);
size_t onnx__attribute_proto__get_packed_size
                     (const Onnx__AttributeProto *message);
size_t onnx__attribute_proto__pack
                     (const Onnx__AttributeProto *message,
                      uint8_t *out);
size_t onnx__attribute_proto__pack_to_buffer
                     (const Onnx__AttributeProto *message,
                      ProtobufCBuffer *buffer);
Onnx__AttributeProto *
       onnx__attribute_proto__unpack
                     (ProtobufCAllocator *allocator,
                      size_t len,
                      const uint8_t *data);
void onnx__attribute_proto__free_unpacked
                     (Onnx__AttributeProto *message,
                      ProtobufCAllocator *allocator);
void onnx__value_info_proto__init
                     (Onnx__ValueInfoProto *message);
size_t onnx__value_info_proto__get_packed_size
                     (const Onnx__ValueInfoProto *message);
size_t onnx__value_info_proto__pack
                     (const Onnx__ValueInfoProto *message,
                      uint8_t *out);
size_t onnx__value_info_proto__pack_to_buffer
                     (const Onnx__ValueInfoProto *message,
                      ProtobufCBuffer *buffer);
Onnx__ValueInfoProto *
       onnx__value_info_proto__unpack
                     (ProtobufCAllocator *allocator,
                      size_t len,
                      const uint8_t *data);
void onnx__value_info_proto__free_unpacked
                     (Onnx__ValueInfoProto *message,
                      ProtobufCAllocator *allocator);
void onnx__node_proto__init
                     (Onnx__NodeProto *message);
size_t onnx__node_proto__get_packed_size
                     (const Onnx__NodeProto *message);
size_t onnx__node_proto__pack
                     (const Onnx__NodeProto *message,
                      uint8_t *out);
size_t onnx__node_proto__pack_to_buffer
                     (const Onnx__NodeProto *message,
                      ProtobufCBuffer *buffer);
Onnx__NodeProto *
       onnx__node_proto__unpack
                     (ProtobufCAllocator *allocator,
                      size_t len,
                      const uint8_t *data);
void onnx__node_proto__free_unpacked
                     (Onnx__NodeProto *message,
                      ProtobufCAllocator *allocator);
void onnx__training_info_proto__init
                     (Onnx__TrainingInfoProto *message);
size_t onnx__training_info_proto__get_packed_size
                     (const Onnx__TrainingInfoProto *message);
size_t onnx__training_info_proto__pack
                     (const Onnx__TrainingInfoProto *message,
                      uint8_t *out);
size_t onnx__training_info_proto__pack_to_buffer
                     (const Onnx__TrainingInfoProto *message,
                      ProtobufCBuffer *buffer);
Onnx__TrainingInfoProto *
       onnx__training_info_proto__unpack
                     (ProtobufCAllocator *allocator,
                      size_t len,
                      const uint8_t *data);
void onnx__training_info_proto__free_unpacked
                     (Onnx__TrainingInfoProto *message,
                      ProtobufCAllocator *allocator);
void onnx__model_proto__init
                     (Onnx__ModelProto *message);
size_t onnx__model_proto__get_packed_size
                     (const Onnx__ModelProto *message);
size_t onnx__model_proto__pack
                     (const Onnx__ModelProto *message,
                      uint8_t *out);
size_t onnx__model_proto__pack_to_buffer
                     (const Onnx__ModelProto *message,
                      ProtobufCBuffer *buffer);
Onnx__ModelProto *
       onnx__model_proto__unpack
                     (ProtobufCAllocator *allocator,
                      size_t len,
                      const uint8_t *data);
void onnx__model_proto__free_unpacked
                     (Onnx__ModelProto *message,
                      ProtobufCAllocator *allocator);
void onnx__string_string_entry_proto__init
                     (Onnx__StringStringEntryProto *message);
size_t onnx__string_string_entry_proto__get_packed_size
                     (const Onnx__StringStringEntryProto *message);
size_t onnx__string_string_entry_proto__pack
                     (const Onnx__StringStringEntryProto *message,
                      uint8_t *out);
size_t onnx__string_string_entry_proto__pack_to_buffer
                     (const Onnx__StringStringEntryProto *message,
                      ProtobufCBuffer *buffer);
Onnx__StringStringEntryProto *
       onnx__string_string_entry_proto__unpack
                     (ProtobufCAllocator *allocator,
                      size_t len,
                      const uint8_t *data);
void onnx__string_string_entry_proto__free_unpacked
                     (Onnx__StringStringEntryProto *message,
                      ProtobufCAllocator *allocator);
void onnx__tensor_annotation__init
                     (Onnx__TensorAnnotation *message);
size_t onnx__tensor_annotation__get_packed_size
                     (const Onnx__TensorAnnotation *message);
size_t onnx__tensor_annotation__pack
                     (const Onnx__TensorAnnotation *message,
                      uint8_t *out);
size_t onnx__tensor_annotation__pack_to_buffer
                     (const Onnx__TensorAnnotation *message,
                      ProtobufCBuffer *buffer);
Onnx__TensorAnnotation *
       onnx__tensor_annotation__unpack
                     (ProtobufCAllocator *allocator,
                      size_t len,
                      const uint8_t *data);
void onnx__tensor_annotation__free_unpacked
                     (Onnx__TensorAnnotation *message,
                      ProtobufCAllocator *allocator);
void onnx__graph_proto__init
                     (Onnx__GraphProto *message);
size_t onnx__graph_proto__get_packed_size
                     (const Onnx__GraphProto *message);
size_t onnx__graph_proto__pack
                     (const Onnx__GraphProto *message,
                      uint8_t *out);
size_t onnx__graph_proto__pack_to_buffer
                     (const Onnx__GraphProto *message,
                      ProtobufCBuffer *buffer);
Onnx__GraphProto *
       onnx__graph_proto__unpack
                     (ProtobufCAllocator *allocator,
                      size_t len,
                      const uint8_t *data);
void onnx__graph_proto__free_unpacked
                     (Onnx__GraphProto *message,
                      ProtobufCAllocator *allocator);
void onnx__tensor_proto__segment__init
                     (Onnx__TensorProto__Segment *message);
void onnx__tensor_proto__init
                     (Onnx__TensorProto *message);
size_t onnx__tensor_proto__get_packed_size
                     (const Onnx__TensorProto *message);
size_t onnx__tensor_proto__pack
                     (const Onnx__TensorProto *message,
                      uint8_t *out);
size_t onnx__tensor_proto__pack_to_buffer
                     (const Onnx__TensorProto *message,
                      ProtobufCBuffer *buffer);
Onnx__TensorProto *
       onnx__tensor_proto__unpack
                     (ProtobufCAllocator *allocator,
                      size_t len,
                      const uint8_t *data);
void onnx__tensor_proto__free_unpacked
                     (Onnx__TensorProto *message,
                      ProtobufCAllocator *allocator);
void onnx__sparse_tensor_proto__init
                     (Onnx__SparseTensorProto *message);
size_t onnx__sparse_tensor_proto__get_packed_size
                     (const Onnx__SparseTensorProto *message);
size_t onnx__sparse_tensor_proto__pack
                     (const Onnx__SparseTensorProto *message,
                      uint8_t *out);
size_t onnx__sparse_tensor_proto__pack_to_buffer
                     (const Onnx__SparseTensorProto *message,
                      ProtobufCBuffer *buffer);
Onnx__SparseTensorProto *
       onnx__sparse_tensor_proto__unpack
                     (ProtobufCAllocator *allocator,
                      size_t len,
                      const uint8_t *data);
void onnx__sparse_tensor_proto__free_unpacked
                     (Onnx__SparseTensorProto *message,
                      ProtobufCAllocator *allocator);
void onnx__tensor_shape_proto__dimension__init
                     (Onnx__TensorShapeProto__Dimension *message);
void onnx__tensor_shape_proto__init
                     (Onnx__TensorShapeProto *message);
size_t onnx__tensor_shape_proto__get_packed_size
                     (const Onnx__TensorShapeProto *message);
size_t onnx__tensor_shape_proto__pack
                     (const Onnx__TensorShapeProto *message,
                      uint8_t *out);
size_t onnx__tensor_shape_proto__pack_to_buffer
                     (const Onnx__TensorShapeProto *message,
                      ProtobufCBuffer *buffer);
Onnx__TensorShapeProto *
       onnx__tensor_shape_proto__unpack
                     (ProtobufCAllocator *allocator,
                      size_t len,
                      const uint8_t *data);
void onnx__tensor_shape_proto__free_unpacked
                     (Onnx__TensorShapeProto *message,
                      ProtobufCAllocator *allocator);
void onnx__type_proto__tensor__init
                     (Onnx__TypeProto__Tensor *message);
void onnx__type_proto__sequence__init
                     (Onnx__TypeProto__Sequence *message);
void onnx__type_proto__map__init
                     (Onnx__TypeProto__Map *message);
void onnx__type_proto__init
                     (Onnx__TypeProto *message);
size_t onnx__type_proto__get_packed_size
                     (const Onnx__TypeProto *message);
size_t onnx__type_proto__pack
                     (const Onnx__TypeProto *message,
                      uint8_t *out);
size_t onnx__type_proto__pack_to_buffer
                     (const Onnx__TypeProto *message,
                      ProtobufCBuffer *buffer);
Onnx__TypeProto *
       onnx__type_proto__unpack
                     (ProtobufCAllocator *allocator,
                      size_t len,
                      const uint8_t *data);
void onnx__type_proto__free_unpacked
                     (Onnx__TypeProto *message,
                      ProtobufCAllocator *allocator);
void onnx__operator_set_id_proto__init
                     (Onnx__OperatorSetIdProto *message);
size_t onnx__operator_set_id_proto__get_packed_size
                     (const Onnx__OperatorSetIdProto *message);
size_t onnx__operator_set_id_proto__pack
                     (const Onnx__OperatorSetIdProto *message,
                      uint8_t *out);
size_t onnx__operator_set_id_proto__pack_to_buffer
                     (const Onnx__OperatorSetIdProto *message,
                      ProtobufCBuffer *buffer);
Onnx__OperatorSetIdProto *
       onnx__operator_set_id_proto__unpack
                     (ProtobufCAllocator *allocator,
                      size_t len,
                      const uint8_t *data);
void onnx__operator_set_id_proto__free_unpacked
                     (Onnx__OperatorSetIdProto *message,
                      ProtobufCAllocator *allocator);
typedef void (*Onnx__AttributeProto_Closure)
                 (const Onnx__AttributeProto *message,
                  void *closure_data);
typedef void (*Onnx__ValueInfoProto_Closure)
                 (const Onnx__ValueInfoProto *message,
                  void *closure_data);
typedef void (*Onnx__NodeProto_Closure)
                 (const Onnx__NodeProto *message,
                  void *closure_data);
typedef void (*Onnx__TrainingInfoProto_Closure)
                 (const Onnx__TrainingInfoProto *message,
                  void *closure_data);
typedef void (*Onnx__ModelProto_Closure)
                 (const Onnx__ModelProto *message,
                  void *closure_data);
typedef void (*Onnx__StringStringEntryProto_Closure)
                 (const Onnx__StringStringEntryProto *message,
                  void *closure_data);
typedef void (*Onnx__TensorAnnotation_Closure)
                 (const Onnx__TensorAnnotation *message,
                  void *closure_data);
typedef void (*Onnx__GraphProto_Closure)
                 (const Onnx__GraphProto *message,
                  void *closure_data);
typedef void (*Onnx__TensorProto__Segment_Closure)
                 (const Onnx__TensorProto__Segment *message,
                  void *closure_data);
typedef void (*Onnx__TensorProto_Closure)
                 (const Onnx__TensorProto *message,
                  void *closure_data);
typedef void (*Onnx__SparseTensorProto_Closure)
                 (const Onnx__SparseTensorProto *message,
                  void *closure_data);
typedef void (*Onnx__TensorShapeProto__Dimension_Closure)
                 (const Onnx__TensorShapeProto__Dimension *message,
                  void *closure_data);
typedef void (*Onnx__TensorShapeProto_Closure)
                 (const Onnx__TensorShapeProto *message,
                  void *closure_data);
typedef void (*Onnx__TypeProto__Tensor_Closure)
                 (const Onnx__TypeProto__Tensor *message,
                  void *closure_data);
typedef void (*Onnx__TypeProto__Sequence_Closure)
                 (const Onnx__TypeProto__Sequence *message,
                  void *closure_data);
typedef void (*Onnx__TypeProto__Map_Closure)
                 (const Onnx__TypeProto__Map *message,
                  void *closure_data);
typedef void (*Onnx__TypeProto_Closure)
                 (const Onnx__TypeProto *message,
                  void *closure_data);
typedef void (*Onnx__OperatorSetIdProto_Closure)
                 (const Onnx__OperatorSetIdProto *message,
                  void *closure_data);
extern const ProtobufCEnumDescriptor onnx__version__descriptor;
extern const ProtobufCMessageDescriptor onnx__attribute_proto__descriptor;
extern const ProtobufCEnumDescriptor onnx__attribute_proto__attribute_type__descriptor;
extern const ProtobufCMessageDescriptor onnx__value_info_proto__descriptor;
extern const ProtobufCMessageDescriptor onnx__node_proto__descriptor;
extern const ProtobufCMessageDescriptor onnx__training_info_proto__descriptor;
extern const ProtobufCMessageDescriptor onnx__model_proto__descriptor;
extern const ProtobufCMessageDescriptor onnx__string_string_entry_proto__descriptor;
extern const ProtobufCMessageDescriptor onnx__tensor_annotation__descriptor;
extern const ProtobufCMessageDescriptor onnx__graph_proto__descriptor;
extern const ProtobufCMessageDescriptor onnx__tensor_proto__descriptor;
extern const ProtobufCMessageDescriptor onnx__tensor_proto__segment__descriptor;
extern const ProtobufCEnumDescriptor onnx__tensor_proto__data_type__descriptor;
extern const ProtobufCEnumDescriptor onnx__tensor_proto__data_location__descriptor;
extern const ProtobufCMessageDescriptor onnx__sparse_tensor_proto__descriptor;
extern const ProtobufCMessageDescriptor onnx__tensor_shape_proto__descriptor;
extern const ProtobufCMessageDescriptor onnx__tensor_shape_proto__dimension__descriptor;
extern const ProtobufCMessageDescriptor onnx__type_proto__descriptor;
extern const ProtobufCMessageDescriptor onnx__type_proto__tensor__descriptor;
extern const ProtobufCMessageDescriptor onnx__type_proto__sequence__descriptor;
extern const ProtobufCMessageDescriptor onnx__type_proto__map__descriptor;
extern const ProtobufCMessageDescriptor onnx__operator_set_id_proto__descriptor;
struct onnx_tensor_t;
struct onnx_node_t;
struct onnx_graph_t;
struct onnx_context_t;
struct onnx_resolver_t;
enum onnx_tensor_type_t {
 ONNX_TENSOR_TYPE_UNDEFINED = 0,
 ONNX_TENSOR_TYPE_BOOL = 9,
 ONNX_TENSOR_TYPE_INT8 = 3,
 ONNX_TENSOR_TYPE_INT16 = 5,
 ONNX_TENSOR_TYPE_INT32 = 6,
 ONNX_TENSOR_TYPE_INT64 = 7,
 ONNX_TENSOR_TYPE_UINT8 = 2,
 ONNX_TENSOR_TYPE_UINT16 = 4,
 ONNX_TENSOR_TYPE_UINT32 = 12,
 ONNX_TENSOR_TYPE_UINT64 = 13,
 ONNX_TENSOR_TYPE_BFLOAT16 = 16,
 ONNX_TENSOR_TYPE_FLOAT16 = 10,
 ONNX_TENSOR_TYPE_FLOAT32 = 1,
 ONNX_TENSOR_TYPE_FLOAT64 = 11,
 ONNX_TENSOR_TYPE_COMPLEX64 = 14,
 ONNX_TENSOR_TYPE_COMPLEX128 = 15,
 ONNX_TENSOR_TYPE_STRING = 8,
};
struct onnx_tensor_t {
 char * name;
 enum onnx_tensor_type_t type;
 int * strides;
 int * dims;
 int ndim;
 void * datas;
 size_t ndata;
};
struct onnx_node_t {
 struct onnx_context_t * ctx;
 struct onnx_resolver_t * r;
 void * rctx;
 int opset;
 struct onnx_tensor_t ** inputs;
 int ninput;
 struct onnx_tensor_t ** outputs;
 int noutput;
 Onnx__NodeProto * proto;
 int (*init)(struct onnx_node_t * n);
 int (*exit)(struct onnx_node_t * n);
 int (*reshape)(struct onnx_node_t * n);
 void (*operator)(struct onnx_node_t * n);
 void * priv;
};
struct onnx_graph_t {
 struct onnx_node_t * nodes;
 int nlen;
};
struct onnx_context_t {
 Onnx__ModelProto * model;
 struct hmap_t * map;
 struct onnx_resolver_t ** r;
 void ** rctx;
 int rlen;
 struct onnx_graph_t * g;
};
struct onnx_resolver_t {
 const char * name;
 void * (*create)(void);
 void (*destroy)(void * rctx);
 void (*op_Abs)(struct onnx_node_t * n);
 void (*op_Acos)(struct onnx_node_t * n);
 void (*op_Acosh)(struct onnx_node_t * n);
 void (*op_Add)(struct onnx_node_t * n);
 void (*op_And)(struct onnx_node_t * n);
 void (*op_ArgMax)(struct onnx_node_t * n);
 void (*op_ArgMin)(struct onnx_node_t * n);
 void (*op_Asin)(struct onnx_node_t * n);
 void (*op_Asinh)(struct onnx_node_t * n);
 void (*op_Atan)(struct onnx_node_t * n);
 void (*op_Atanh)(struct onnx_node_t * n);
 void (*op_AveragePool)(struct onnx_node_t * n);
 void (*op_BatchNormalization)(struct onnx_node_t * n);
 void (*op_BitShift)(struct onnx_node_t * n);
 void (*op_Cast)(struct onnx_node_t * n);
 void (*op_Ceil)(struct onnx_node_t * n);
 void (*op_Clip)(struct onnx_node_t * n);
 void (*op_Compress)(struct onnx_node_t * n);
 void (*op_Concat)(struct onnx_node_t * n);
 void (*op_ConcatFromSequence)(struct onnx_node_t * n);
 void (*op_Constant)(struct onnx_node_t * n);
 void (*op_ConstantOfShape)(struct onnx_node_t * n);
 void (*op_Conv)(struct onnx_node_t * n);
 void (*op_ConvInteger)(struct onnx_node_t * n);
 void (*op_ConvTranspose)(struct onnx_node_t * n);
 void (*op_Cos)(struct onnx_node_t * n);
 void (*op_Cosh)(struct onnx_node_t * n);
 void (*op_CumSum)(struct onnx_node_t * n);
 void (*op_DepthToSpace)(struct onnx_node_t * n);
 void (*op_DequantizeLinear)(struct onnx_node_t * n);
 void (*op_Det)(struct onnx_node_t * n);
 void (*op_Div)(struct onnx_node_t * n);
 void (*op_Dropout)(struct onnx_node_t * n);
 void (*op_Einsum)(struct onnx_node_t * n);
 void (*op_Elu)(struct onnx_node_t * n);
 void (*op_Equal)(struct onnx_node_t * n);
 void (*op_Erf)(struct onnx_node_t * n);
 void (*op_Exp)(struct onnx_node_t * n);
 void (*op_Expand)(struct onnx_node_t * n);
 void (*op_EyeLike)(struct onnx_node_t * n);
 void (*op_Flatten)(struct onnx_node_t * n);
 void (*op_Floor)(struct onnx_node_t * n);
 void (*op_GRU)(struct onnx_node_t * n);
 void (*op_Gather)(struct onnx_node_t * n);
 void (*op_GatherElements)(struct onnx_node_t * n);
 void (*op_GatherND)(struct onnx_node_t * n);
 void (*op_Gemm)(struct onnx_node_t * n);
 void (*op_GlobalAveragePool)(struct onnx_node_t * n);
 void (*op_GlobalLpPool)(struct onnx_node_t * n);
 void (*op_GlobalMaxPool)(struct onnx_node_t * n);
 void (*op_Greater)(struct onnx_node_t * n);
 void (*op_HardSigmoid)(struct onnx_node_t * n);
 void (*op_Hardmax)(struct onnx_node_t * n);
 void (*op_Identity)(struct onnx_node_t * n);
 void (*op_If)(struct onnx_node_t * n);
 void (*op_InstanceNormalization)(struct onnx_node_t * n);
 void (*op_IsInf)(struct onnx_node_t * n);
 void (*op_IsNaN)(struct onnx_node_t * n);
 void (*op_LRN)(struct onnx_node_t * n);
 void (*op_LSTM)(struct onnx_node_t * n);
 void (*op_LeakyRelu)(struct onnx_node_t * n);
 void (*op_Less)(struct onnx_node_t * n);
 void (*op_Log)(struct onnx_node_t * n);
 void (*op_Loop)(struct onnx_node_t * n);
 void (*op_LpNormalization)(struct onnx_node_t * n);
 void (*op_LpPool)(struct onnx_node_t * n);
 void (*op_MatMul)(struct onnx_node_t * n);
 void (*op_MatMulInteger)(struct onnx_node_t * n);
 void (*op_Max)(struct onnx_node_t * n);
 void (*op_MaxPool)(struct onnx_node_t * n);
 void (*op_MaxRoiPool)(struct onnx_node_t * n);
 void (*op_MaxUnpool)(struct onnx_node_t * n);
 void (*op_Mean)(struct onnx_node_t * n);
 void (*op_Min)(struct onnx_node_t * n);
 void (*op_Mod)(struct onnx_node_t * n);
 void (*op_Mul)(struct onnx_node_t * n);
 void (*op_Multinomial)(struct onnx_node_t * n);
 void (*op_Neg)(struct onnx_node_t * n);
 void (*op_NonMaxSuppression)(struct onnx_node_t * n);
 void (*op_NonZero)(struct onnx_node_t * n);
 void (*op_Not)(struct onnx_node_t * n);
 void (*op_OneHot)(struct onnx_node_t * n);
 void (*op_Or)(struct onnx_node_t * n);
 void (*op_PRelu)(struct onnx_node_t * n);
 void (*op_Pad)(struct onnx_node_t * n);
 void (*op_Pow)(struct onnx_node_t * n);
 void (*op_QLinearConv)(struct onnx_node_t * n);
 void (*op_QLinearMatMul)(struct onnx_node_t * n);
 void (*op_QuantizeLinear)(struct onnx_node_t * n);
 void (*op_RNN)(struct onnx_node_t * n);
 void (*op_RandomNormal)(struct onnx_node_t * n);
 void (*op_RandomNormalLike)(struct onnx_node_t * n);
 void (*op_RandomUniform)(struct onnx_node_t * n);
 void (*op_RandomUniformLike)(struct onnx_node_t * n);
 void (*op_Reciprocal)(struct onnx_node_t * n);
 void (*op_ReduceL1)(struct onnx_node_t * n);
 void (*op_ReduceL2)(struct onnx_node_t * n);
 void (*op_ReduceLogSum)(struct onnx_node_t * n);
 void (*op_ReduceLogSumExp)(struct onnx_node_t * n);
 void (*op_ReduceMax)(struct onnx_node_t * n);
 void (*op_ReduceMean)(struct onnx_node_t * n);
 void (*op_ReduceMin)(struct onnx_node_t * n);
 void (*op_ReduceProd)(struct onnx_node_t * n);
 void (*op_ReduceSum)(struct onnx_node_t * n);
 void (*op_ReduceSumSquare)(struct onnx_node_t * n);
 void (*op_Relu)(struct onnx_node_t * n);
 void (*op_Reshape)(struct onnx_node_t * n);
 void (*op_Resize)(struct onnx_node_t * n);
 void (*op_ReverseSequence)(struct onnx_node_t * n);
 void (*op_RoiAlign)(struct onnx_node_t * n);
 void (*op_Round)(struct onnx_node_t * n);
 void (*op_Scan)(struct onnx_node_t * n);
 void (*op_Scatter)(struct onnx_node_t * n);
 void (*op_ScatterElements)(struct onnx_node_t * n);
 void (*op_ScatterND)(struct onnx_node_t * n);
 void (*op_Selu)(struct onnx_node_t * n);
 void (*op_SequenceAt)(struct onnx_node_t * n);
 void (*op_SequenceConstruct)(struct onnx_node_t * n);
 void (*op_SequenceEmpty)(struct onnx_node_t * n);
 void (*op_SequenceErase)(struct onnx_node_t * n);
 void (*op_SequenceInsert)(struct onnx_node_t * n);
 void (*op_SequenceLength)(struct onnx_node_t * n);
 void (*op_Shape)(struct onnx_node_t * n);
 void (*op_Shrink)(struct onnx_node_t * n);
 void (*op_Sigmoid)(struct onnx_node_t * n);
 void (*op_Sign)(struct onnx_node_t * n);
 void (*op_Sin)(struct onnx_node_t * n);
 void (*op_Sinh)(struct onnx_node_t * n);
 void (*op_Size)(struct onnx_node_t * n);
 void (*op_Slice)(struct onnx_node_t * n);
 void (*op_Softplus)(struct onnx_node_t * n);
 void (*op_Softsign)(struct onnx_node_t * n);
 void (*op_SpaceToDepth)(struct onnx_node_t * n);
 void (*op_Split)(struct onnx_node_t * n);
 void (*op_SplitToSequence)(struct onnx_node_t * n);
 void (*op_Sqrt)(struct onnx_node_t * n);
 void (*op_Squeeze)(struct onnx_node_t * n);
 void (*op_StringNormalizer)(struct onnx_node_t * n);
 void (*op_Sub)(struct onnx_node_t * n);
 void (*op_Sum)(struct onnx_node_t * n);
 void (*op_Tan)(struct onnx_node_t * n);
 void (*op_Tanh)(struct onnx_node_t * n);
 void (*op_TfIdfVectorizer)(struct onnx_node_t * n);
 void (*op_ThresholdedRelu)(struct onnx_node_t * n);
 void (*op_Tile)(struct onnx_node_t * n);
 void (*op_TopK)(struct onnx_node_t * n);
 void (*op_Transpose)(struct onnx_node_t * n);
 void (*op_Trilu)(struct onnx_node_t * n);
 void (*op_Unique)(struct onnx_node_t * n);
 void (*op_Unsqueeze)(struct onnx_node_t * n);
 void (*op_Upsample)(struct onnx_node_t * n);
 void (*op_Where)(struct onnx_node_t * n);
 void (*op_Xor)(struct onnx_node_t * n);
 void (*op_Celu)(struct onnx_node_t * n);
 void (*op_DynamicQuantizeLinear)(struct onnx_node_t * n);
 void (*op_GreaterOrEqual)(struct onnx_node_t * n);
 void (*op_HardSwish)(struct onnx_node_t * n);
 void (*op_LessOrEqual)(struct onnx_node_t * n);
 void (*op_LogSoftmax)(struct onnx_node_t * n);
 void (*op_MeanVarianceNormalization)(struct onnx_node_t * n);
 void (*op_NegativeLogLikelihoodLoss)(struct onnx_node_t * n);
 void (*op_Range)(struct onnx_node_t * n);
 void (*op_Softmax)(struct onnx_node_t * n);
 void (*op_SoftmaxCrossEntropyLoss)(struct onnx_node_t * n);
};
struct onnx_context_t * onnx_context_alloc(const void * buf, size_t len, struct onnx_resolver_t ** r, int rlen);
struct onnx_context_t * onnx_context_alloc_from_file(const char * filename, struct onnx_resolver_t ** r, int rlen);
void onnx_context_free(struct onnx_context_t * ctx);
struct onnx_graph_t * onnx_graph_alloc(struct onnx_context_t * ctx, Onnx__GraphProto * graph);
void onnx_graph_free(struct onnx_graph_t * g);
const char * onnx_tensor_type_tostring(enum onnx_tensor_type_t type);
int onnx_tensor_type_sizeof(enum onnx_tensor_type_t type);
struct onnx_tensor_t * onnx_tensor_search(struct onnx_context_t * ctx, const char * name);
struct onnx_tensor_t * onnx_tensor_alloc(const char * name, enum onnx_tensor_type_t type, int * dims, int ndim);
struct onnx_tensor_t * onnx_tensor_alloc_from_file(const char * filename);
void onnx_tensor_free(struct onnx_tensor_t * t);
int onnx_tensor_equal(struct onnx_tensor_t * a, struct onnx_tensor_t * b);
void onnx_tensor_reinit(struct onnx_tensor_t * t, enum onnx_tensor_type_t type, int * dims, int ndim);
void onnx_tensor_apply(struct onnx_tensor_t * t, void * buf, size_t len);
static int onnx_tensor_is_scalar(struct onnx_tensor_t * t)
;
static int onnx_tensor_broadcast_is_valid(struct onnx_tensor_t * x, int * dims, int ndim)
;
static int onnx_tensor_indices_to_offset(struct onnx_tensor_t * t, int * indices)
;
static void onnx_tensor_offset_to_indices(struct onnx_tensor_t * t, int offset, int * indices)
;
static int onnx_tensor_reshape(struct onnx_tensor_t * y, int * dims, int ndim, enum onnx_tensor_type_t type)
;
static int onnx_tensor_reshape_identity(struct onnx_tensor_t * y, struct onnx_tensor_t * x, enum onnx_tensor_type_t type)
;
static int onnx_tensor_reshape_multi_broadcast(struct onnx_tensor_t * y, struct onnx_tensor_t * a, struct onnx_tensor_t * b, enum onnx_tensor_type_t type)
;
static void * onnx_tensor_broadcast_map_address(struct onnx_tensor_t * x, struct onnx_tensor_t * y, int offset)
;
float onnx_attribute_read_float(struct onnx_node_t * n, const char * name, float def);
int64_t onnx_attribute_read_int(struct onnx_node_t * n, const char * name, int64_t def);
char * onnx_attribute_read_string(struct onnx_node_t * n, const char * name, char * def);
int onnx_attribute_read_ints(struct onnx_node_t * n, const char * name, int64_t ** ints);
int onnx_attribute_read_floats(struct onnx_node_t * n, const char * name, float ** floats);
int onnx_attribute_read_tensor(struct onnx_node_t * n, const char * name, struct onnx_tensor_t * t);
Onnx__GraphProto * onnx_attribute_read_graph(struct onnx_node_t * n, const char * name, Onnx__GraphProto * def);
Onnx__SparseTensorProto * onnx_attribute_read_sparse_tensor(struct onnx_node_t * n, const char * name, Onnx__SparseTensorProto * def);
void onnx_tensor_dump(struct onnx_tensor_t * t, int detail);
void onnx_node_dump(struct onnx_node_t * n, int detail);
void onnx_graph_dump(struct onnx_graph_t * g, int detail);
void onnx_context_dump(struct onnx_context_t * ctx, int detail);
void onnx_run(struct onnx_context_t * ctx);
enum auto_pad_t {
 AUTO_PAD_NOTSET = 0,
 AUTO_PAD_SAME_UPPER = 1,
 AUTO_PAD_SAME_LOWER = 2,
 AUTO_PAD_VALID = 3,
};
enum conv_mode_t {
 CONV_SIMPLE = 0,
 CONV_CACHED = 1,
 CONV_IM2COL = 2,
};
struct operator_pdata_t {
 enum auto_pad_t auto_pad;
 int group;
 int * kernels;
 int nkernel;
 int * dilations;
 int ndilation;
 int * pads;
 int npad;
 int * strides;
 int nstride;
 int cpads[32];
};
static int Conv_init(struct onnx_node_t * n)
;
static int Conv_exit(struct onnx_node_t * n)
;
static int Conv_reshape(struct onnx_node_t * n)
;
static int dim_next(int ndim, int * dims, int * dim_max)
;
static int dim_offset(int ndim, int * dims, int * dim_max)
;
static void dgemm_float32(int n, int m, int o, float * A, float * B, float * C)
;
static void dgemm_float64(int n, int m, int o, double * A, double * B, double * C)
;
static void Conv_float16(struct onnx_node_t * n)
;
static void Conv_float32(struct onnx_node_t * n)
;
static void Conv_float64(struct onnx_node_t * n)
;
void resolver_default_op_Conv(struct onnx_node_t * n)
;
